;;mh3d
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mh3d text size font pat bgm bg-color bgg bgp scolor sblur soff ft?)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 12) 4) TRUE size PIXELS font)))
;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))
)
(gimp-image-undo-disable img)
;;TCY
    (gimp-image-resize img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (/ (* sblur 1.1) 2) (/ (* sblur 1.1) 2))

    (script-fu-mh3dimg img text-layer size pat bgm bg-color bgg bgp scolor sblur soff ft?)

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-active old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mh3d"
		    "<Image>/File/Create/Logos/3D Logo..."
		    "mh3d"
		    "Kiki"
		    "Kiki"
		    "2005/3"
		    ""
		    SF-STRING   "Text String"      "3D Logo"
		    SF-ADJUSTMENT "Font Size (pixels)" '(120 2 1000 1 10 0 1)
		    SF-FONT     "Font"             "GoSoul"
                    SF-PATTERN  "Pattern"          "mhline"
                    SF-OPTION   "bg mode"          '(_"color" _"grad" _"pattern")
		    SF-COLOR    "Background Color" '(205 255 182)
                    SF-GRADIENT "Background Gradient"     "Purples"
                    SF-PATTERN  "Background Pattern"      "Parque #3"
		    SF-COLOR    "Shadow Color" '(30 30 30)
		    SF-ADJUSTMENT	"shadow blur"	'(6 0 100 1 2 0 1)
		    SF-ADJUSTMENT	"shadow offset"	'(4 0 100 1 2 0 1)
                    SF-TOGGLE   "Flatten Image"          TRUE)

(define (script-fu-mh3dimg img drawable size pat bgm bg-color bgg bgp scolor sblur soff ft?)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
;;wiȂ
	 (bg-layer (car (gimp-layer-new img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) RGB-IMAGE "Background" 100 NORMAL)))
	 (pt-layer (car (gimp-layer-new img width height RGBA-IMAGE "Pattern" 100 NORMAL)))
	 (wt-layer (car (gimp-layer-new img width height RGBA-IMAGE "white" 100 NORMAL)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))

;;2.4ǉ
	 (oc2)
	 (wt2)
	 (blur)
	 (shou)
)
    (gimp-undo-push-group-start img)

;;OiF̌
    (gimp-palette-set-foreground '(0 0 0))
    (gimp-layer-set-preserve-trans drawable TRUE)
    (gimp-edit-fill drawable FG-IMAGE-FILL)
    (gimp-layer-set-preserve-trans drawable FALSE)
    (set! oc2 (car (gimp-layer-copy drawable 0)))	;C[̃Rs[쐬
    (gimp-image-add-layer img pt-layer 0)		;C[ǉ
    (gimp-image-add-layer img wt-layer 0)		;C[ǉ
    (gimp-selection-all img)
    (gimp-patterns-set-pattern pat)
    (gimp-bucket-fill pt-layer PATTERN-BUCKET-FILL NORMAL 100 255 FALSE 0 0)
    (gimp-palette-set-foreground '(255 255 255))
    (gimp-edit-fill wt-layer FG-IMAGE-FILL)
    (gimp-selection-none img)
;    (if (< width height) (set! height width))
;    (if (< 200 height) (set! height 200))
    (plug-in-gauss-iir2 1 img drawable (/ size 7) (/ size 7))
    (plug-in-displace 1 img pt-layer 20 20 TRUE TRUE drawable drawable 0)

    (gimp-layer-resize drawable (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (+ soff (* sblur 0.55)) (+ soff (* sblur 0.55)))	;important
    (gimp-layer-translate pt-layer (/ (* sblur 1.1) 2) (/ (* sblur 1.1) 2))
    (gimp-layer-translate wt-layer (/ (* sblur 1.1) 2) (/ (* sblur 1.1) 2))

    (gimp-image-add-layer img oc2 2)			;C[ǉ2.8(Ɉړ)
    (gimp-layer-resize oc2 (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (+ soff (* sblur 0.55)) (+ soff (* sblur 0.55)))	;important
    (gimp-selection-layer-alpha oc2)
    (gimp-palette-set-foreground scolor)
    (gimp-edit-fill oc2 FG-IMAGE-FILL)
    (gimp-edit-clear wt-layer)				;I𕔕폜
    (gimp-selection-invert img)				;I͈͂𔽓]
    (gimp-edit-clear pt-layer)				;I𕔕폜
    (gimp-selection-none img)
    (set! blur (/ size 10))
    (if (> blur 20) (set! blur 20))
    (plug-in-gauss-iir2 1 img wt-layer blur blur)
    (gimp-selection-layer-alpha oc2)
    (gimp-selection-invert img)				;I͈͂𔽓]
    (gimp-edit-clear wt-layer)				;I𕔕폜
    (gimp-image-remove-layer img drawable)		;C[
    (gimp-selection-none img)
    (set! wt2 (car (gimp-layer-copy wt-layer 0)))	;C[̃Rs[쐬
    (gimp-image-add-layer img wt2 0)			;C[ǉ
;;;;;    (gimp-image-add-layer img oc2 3)		;C[ǉ
    (gimp-layer-translate oc2 soff soff)		;e̍쐬	;moved
    (if (>= sblur 1) (plug-in-gauss-iir2 1 img oc2 sblur sblur))
    (gimp-layer-set-opacity oc2 70)			;x

;;wiF̌(bg-layeř̐̓C[̏Ԃł)
    (gimp-palette-set-foreground bg-color)
    (gimp-image-add-layer img bg-layer 4)
    (gimp-drawable-fill bg-layer FG-IMAGE-FILL)
    (cond((= bgm 1)
       (gimp-gradients-set-active bgg)                      ;Of[V̐ݒ
       (gimp-blend bg-layer CUSTOM NORMAL LINEAR 100 20 REPEAT-NONE FALSE 0 0 0 0 0 0 0 height))
    ((= bgm 2)
       (gimp-selection-all img)
       (gimp-patterns-set-pattern bgp)
       (gimp-bucket-fill bg-layer PATTERN-BUCKET-FILL NORMAL 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))

    (set! width (car (gimp-drawable-width bg-layer)))		;add
    (set! height (car (gimp-drawable-height bg-layer)))		;add
    (if (>= soff sblur ) (set! shou sblur)			;add
	(set! shou soff)					;add
    )								;add
    (gimp-image-resize img (- width (/ shou 2))  (- height (/ shou 2)) (- 0 (/ shou 2)) (- 0 (/ shou 2)))	;add
    (gimp-layer-resize bg-layer (- width (/ shou 2))  (- height (/ shou 2)) (- 0 (/ shou 2)) (- 0 (/ shou 2)))	;add

    (if (= ft? TRUE)
    (gimp-image-flatten img)     	     ;摜̓
    )

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-active old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-undo-push-group-end img)
    (gimp-displays-flush)
))

(define (script-fu-mh3dimgh img drawable size pat bgm bg-color bgg bgp scolor sblur soff ft?)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
  )

    (gimp-image-resize img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (/ (* sblur 1.1) 2) (/ (* sblur 1.1) 2))
    (script-fu-mh3dimg img drawable size pat bgm bg-color bgg bgp scolor sblur soff ft?)
)
)

(script-fu-register "script-fu-mh3dimgh"
		    "<Image>/Script-Fu/MH/3d"
		    "mh3dimg"
		    "Kiki"
		    "Kiki"
		    "2005/3"
		    "RGBA"
		    SF-IMAGE    "Image"            0
		    SF-DRAWABLE "Drawable"         0
		    SF-ADJUSTMENT "Size (pixels)" '(120 2 1000 1 10 0 1)
                    SF-PATTERN  "Pattern"          "mhline"
                    SF-OPTION   "bg mode"          '(_"color" _"grad" _"pattern")
		    SF-COLOR    "Background Color" '(205 255 182)
                    SF-GRADIENT "Background Gradient"     "Purples"
                    SF-PATTERN  "Background Pattern"      "Parque #3"
		    SF-COLOR    "Shadow Color" '(30 30 30)
		    SF-ADJUSTMENT  "shadow blur"	'(6 0 100 1 2 0 1)
		    SF-ADJUSTMENT  "shadow offset"	'(4 0 100 1 2 0 1)
                    SF-TOGGLE   "Flatten Image"     TRUE)
