; Blue Ice-2.8 rel 0.07
; Created by Graechan
;
;    Thanks to Rod for his great tutorial and for compiling the Light to Height plugin
;    that inspired me to write this script. 
;    Comments directed to http://gimpchat.com or http://gimpscripts.com
;    Light to Height plug-in avaiable here http://www.gimpchat.com/viewtopic.php?f=9&t=4725
;    Tutorial is available here http://www.gimpchat.com/viewtopic.php?f=11&t=4713&start=10
;    The Light to Height plugin was ran at end of tutorial, before the drop shadow was added
;    If using script in 2.6 the rain pattern from 2.8 is included with Blue Ice script,
;    just add the pattern to your patterns folder
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
; Rel 0.02 - Added perspective, color and gradient fill to text
; Rel 0.03 - Added a darken footprint option
; Rel 0.04 - Added 'Active Gradient' option
; Rel 0.05 - Improved 'Active Gradient option to use the active f/g b/g colors and Added f/g b/g color selector for 'Gradient' option
; Rel 0.06 - Decreased Menu Box length ['FG to BG (RGB)' gradient] will now use active f/g b/g colors for 'Gradient' and 'Active Gradient'
; Rel 0.07 - Added SteamPunk (with more vibrant colors) to Text fill Types
(define (script-fu-blue-ice 
                                 text 
                                 font-in 
                                 font-size
								 shrink	
                                 blur
                                 type								 
                                 pattern
								 fg-color
								 gradient
								 horizon
								 dark
								 3d-hght
								 per
								 alpha
                                 rel-distance
                                 rel-length
                                 shadow-blur
                                 shadow-opacity
								 cyan-red 
								 magenta-green 
								 yellow-blue
								 )
                                 
  (let* ((image (car (gimp-image-new 256 256 RGB)))
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width 0)
         (height 0)		 
		 (pattern-layer 0)
		 (active-gradient (car (gimp-context-get-gradient)))
		 (active-fg (car (gimp-context-get-foreground)))
		 (active-bg (car (gimp-context-get-background)))
		 (text-channel 0)
		 (map-channel 0)
		 (brushName    "outlineBrush")
		 (outline-in 2.5)
		 (outline (/ outline-in 2))
		 (vectors 0)
		 (*newpoint* (cons-array 6 'double))
		 (brightcont 60)		 
         )
		 
    (gimp-context-push)
    (gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
;;;;Add the text layer for a temporary larger Image size
    (gimp-image-remove-layer image size-layer)
	(set! text-layer (car (gimp-text-fontname image -1 0 0 text 158 TRUE 632 PIXELS font)))
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))
    (gimp-image-resize-to-layers image)
	
;;;;set the text clolor    
    (gimp-context-set-foreground '(119 119 119))
	(gimp-selection-layer-alpha text-layer)
	(gimp-edit-fill text-layer FOREGROUND-FILL)

;;;;Expand the font if needed 
;    (if (> grow 0)
;           (begin
;    (gimp-edit-clear text-layer)
;    (gimp-selection-grow image grow)
;	(gimp-context-set-foreground '(119 119 119))
;    (gimp-edit-fill text-layer FOREGROUND-FILL)    
;           )
;    )	
	
;;;;create text-channel for lighting bump map
	(gimp-selection-save image)
	(set! text-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity text-channel 100)	
	(gimp-drawable-set-name text-channel "text-channel")
	
    (gimp-drawable-set-visible text-layer FALSE)
    (gimp-drawable-set-visible text-channel TRUE)

    (gimp-selection-shrink image shrink)
	(gimp-context-set-foreground '(0 0 0))
    (gimp-edit-fill text-channel FOREGROUND-FILL)	
    (gimp-selection-none image)
    
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image text-channel blur blur)
	
	(gimp-image-set-active-layer image text-layer)
	(gimp-drawable-set-visible text-layer TRUE)
    (gimp-drawable-set-visible text-channel FALSE)
	
;;;;run the lighting plugin with a bump map and default settings
	(plug-in-lighting 1 
	    image              ; IMAGE
		text-layer         ; DRAWABLE
		text-channel       ; BUMP MAP
		0                  ; ENVIRONMENT MAP
		TRUE               ; ENABLE BUMPMAPPING
		FALSE              ; ENABLE ENVMAPPING
		0                  ; TYPE OF MAPPING
		0                  ; TYPE OF LIGHTSOURCE 
		'(255 255 255)     ; LIGHTSOURCE COLOR
		-1.00              ; LIGHTSOURCE POS X
		-1.00              ; LIGHTSOURCE POS Y
		1.00               ; LIGHTSOURCE POS Z
		-1.00              ; LIGHTSOURCE DIR X
		-1.00              ; LIGHTSOURCE DIR Y
		1.00               ; LIGHTSOURCE DIR Z
		0.20               ; AMBIANT INTENSITY (GLOWING)
		0.50               ; DIFFUSE INTENSITY (BRIGHT)
		1.00               ; DIFFUSE REFLECTIVITY (INTENSITY)
		0.50               ; SPECULAR REFLECTIVITY (SHINY)
		27                 ; HIGHLIGHT (POLISHED)
		TRUE               ; ANTIALIASING
		FALSE              ; CREATE NEW IMAGE
		FALSE)	           ; MAKE BACKGROUND TRANSPARENT 	
	
    (gimp-drawable-transform-perspective-default text-layer 0 (- 0 per) width per 0 (+ height per) width (- height per) TRUE 0)
	
;;;;scale the image to its intended size
	(gimp-image-scale-full image final-width final-height 2)
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))	
	
;;;;create the pattern layer
	(set! pattern-layer (car (gimp-layer-new image width height RGBA-IMAGE "Pattern" 100  HARDLIGHT-MODE)))
	(gimp-image-add-layer image pattern-layer -1)
    (gimp-context-set-pattern pattern)
	(gimp-context-set-gradient gradient)
	(gimp-context-set-foreground fg-color)
	(if (or (= type 2) (= type 3)) (begin 
	(gimp-context-set-foreground active-fg)
	(gimp-context-set-background active-bg)))
	(if (= type 3)(gimp-context-set-gradient active-gradient))
    (if (= type 0) (gimp-drawable-fill pattern-layer PATTERN-FILL))
	(if (= type 1) (gimp-drawable-fill pattern-layer FOREGROUND-FILL))
	(if (= type 4) (begin
	(gimp-context-set-foreground "Gray")
	(gimp-context-set-gradient "FG to Transparent")))
	(if (and (> type 1) (< type 5))
    (begin
	(gimp-selection-layer-alpha text-layer)
	(gimp-edit-blend pattern-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width height)
    (gimp-selection-none image)))	
	
	(gimp-image-resize-to-layers image)
    (gimp-image-set-active-layer image text-layer)	
	(set! text-layer (car (gimp-image-merge-visible-layers image  EXPAND-AS-NECESSARY)))

;;;;stroke the text-layer if needed
;;;;create path and stroke
            (if (= dark TRUE)
			(begin
			(gimp-selection-layer-alpha text-layer)      		   
		   ;; define new brush for drawing operation
            (gimp-brush-new brushName)
			(gimp-brush-set-shape brushName BRUSH-GENERATED-CIRCLE)    
            (gimp-brush-set-spikes brushName 2)
            (gimp-brush-set-hardness brushName 1.00)                   
            (gimp-brush-set-aspect-ratio brushName 1.0)
            (gimp-brush-set-angle brushName 0.0)                       
            (gimp-brush-set-spacing brushName 1.0)
            (gimp-brush-set-radius brushName outline)            
            (gimp-context-set-brush brushName)
            (gimp-context-set-foreground '(0 0 0)) 
            (plug-in-sel2path 1 image text-layer)
			(gimp-selection-none image)
			(set! vectors (car (gimp-image-get-active-vectors image)))
			(gimp-edit-stroke-vectors text-layer vectors)
			(gimp-brush-delete brushName)
            (gimp-image-remove-vectors image vectors)
			)
			) ;endif	
	
;;;;create map-channel for Light to Height plugin and run Light to Height
	(gimp-selection-layer-alpha text-layer)
	(gimp-selection-save image)
	(set! map-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity map-channel 100)	
	(gimp-drawable-set-name map-channel "Map Channel")
	(gimp-selection-none image)
	(gimp-image-set-active-layer image text-layer)
	(plug-in-light-to-height 1 image text-layer map-channel 3d-hght 3d-hght TRUE FALSE TRUE horizon)
	
	(if (= type 4) (begin
;	(gimp-color-balance text-layer 0 TRUE cyan-red magenta-green yellow-blue)
	(gimp-color-balance text-layer 0 TRUE cyan-red magenta-green yellow-blue)
	(gimp-color-balance text-layer 1 TRUE cyan-red magenta-green yellow-blue)
	(gimp-color-balance text-layer 2 TRUE cyan-red magenta-green yellow-blue)
	
	(plug-in-lighting 1 
	    image              ; IMAGE
		text-layer         ; DRAWABLE
		text-layer         ; BUMP MAP  (set to 0 if disabled)
		0                  ; ENVIRONMENT MAP  (set to 0 if disabled)
		TRUE               ; ENABLE BUMPMAPPING
		FALSE              ; ENABLE ENVMAPPING
		0                  ; TYPE OF MAPPING (0=linear,1=log, 2=sinusoidal, 3=spherical)
		0                  ; TYPE OF LIGHTSOURCE (0=point,1=directional,3=spot,4=none) 
		'(255 255 255)     ; LIGHTSOURCE COLOR
		-1                 ; LIGHTSOURCE POS X
		-1                 ; LIGHTSOURCE POS Y
		1                  ; LIGHTSOURCE POS Z
		-1                 ; LIGHTSOURCE DIR X
		-1                 ; LIGHTSOURCE DIR Y
		1                  ; LIGHTSOURCE DIR Z
		0.20               ; AMBIANT INTENSITY (GLOWING)
		0.50               ; DIFFUSE INTENSITY (BRIGHT)
		1                  ; DIFFUSE REFLECTIVITY (INTENSITY)
		0.50               ; SPECULAR REFLECTIVITY (SHINY)
		27                 ; HIGHLIGHT (POLISHED)
		TRUE               ; ANTIALIASING
		FALSE              ; CREATE NEW IMAGE
		FALSE)	           ; MAKE BACKGROUND TRANSPARENT
		
		(plug-in-bump-map 1 image text-layer text-layer 135 45 3 0 0 0 0 TRUE TRUE 0)
		
					(aset *newpoint* 0 0)    ; set the arrays
					(aset *newpoint* 1 0)
					(aset *newpoint* 2 50)
	                (aset *newpoint* 3 180)
					(aset *newpoint* 4 255)
					(aset *newpoint* 5 255)
	(gimp-curves-spline text-layer 0 6 *newpoint*)
;    (gimp-brightness-contrast drawable brightness contrast)
	(gimp-brightness-contrast text-layer (- brightcont) brightcont)
		)
		) ;endif

;;;;create the Perspective Shadow    
    (script-fu-perspective-shadow image text-layer alpha rel-distance rel-length shadow-blur '(0 0 0) shadow-opacity 1 TRUE)
	
;	(if (= conserve FALSE) (begin
;	(set! text-layer (car (gimp-image-merge-visible-layers image  EXPAND-AS-NECESSARY)))
	(gimp-image-remove-channel image text-channel)
	(gimp-image-remove-channel image map-channel)
	(gimp-drawable-set-name text-layer text)
	
;;;;[end];;;;
    (gimp-context-pop)   
    (gimp-display-new image)
	
    )
  )
  
(script-fu-register "script-fu-blue-ice"
  "Blue Ice..."
  "Create an image using the Light to Height Plugin"
  "Rod&Graechan"
  "Rod&Graechan"
  "April 2013"
  ""
  SF-STRING     "Text"               "BLUE ICE"
  SF-FONT       "Font"               "Sans Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(350 6 700 1 1 0 1)
  SF-ADJUSTMENT "Bevel Amount less for thin fonts"    '(30 1 40 1 5 0 0)
  SF-ADJUSTMENT "Bevel Angle" '(20 1 40 1 5 0 0)
  SF-OPTION "Text Fill Type" '("Pattern" "Color" "Gradient" "Active Gradient" "SteamPunk" "None")
  SF-PATTERN    "Text Fill Pattern"            "Rain"
  SF-COLOR      "Text Fill Color"         '(174 74 74)
  SF-GRADIENT   "Text Fill Gradient" "Abstract 3"
  SF-TOGGLE     "Face Horizon"   FALSE
  SF-TOGGLE     "Darken 3d Footprint"   FALSE
  SF-ADJUSTMENT "3D Height" '(40 0 100 1 5 0 0)
  SF-ADJUSTMENT "Perspective Size" '(0 -250 250 1 10 0 0)
  SF-ADJUSTMENT _"Perspective Angle"            '(45 0 180 1 10 1 0)
  SF-ADJUSTMENT _"Relative distance of horizon" '(5 0.1 24.1 0.1 1 1 1)
  SF-ADJUSTMENT _"Relative length of shadow"    '(1 0.1 24   0.1 1 1 1)
  SF-ADJUSTMENT _"Perspective Blur radius"      '(3 0 1024 1 10 0 0)
  SF-ADJUSTMENT _"Perspective Opacity"          '(80 0 100 1 10 0 0)
  SF-ADJUSTMENT _"SteamPunk cyan-red"          '(100 -100 100 1 10 0 0)
  SF-ADJUSTMENT _"SteamPunk magenta-green"     '(0 -100 100 1 10 0 0)
  SF-ADJUSTMENT _"SteamPunk yellow-blue"       '(-100 -100 100 1 10 0 0)
  )
(script-fu-menu-register "script-fu-blue-ice" "<Image>/File/Create/Logos")