;;mhbump
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhbump text size font foption tcolor grad gmode pat bwidth bblur bb inv noc)
  (let* ((img (car (gimp-image-new 256 256 RGB)))

;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text 15 TRUE size PIXELS font)))

;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))
)
(gimp-image-undo-disable img)

;;TCY
    (gimp-image-resize img (+ width bwidth) (+ height bwidth) (/ bwidth 2) (/ bwidth 2))
    (gimp-layer-resize text-layer (+ width bwidth) (+ height bwidth) (/ bwidth 2) (/ bwidth 2))

;OiF̐ݒ
  (gimp-palette-set-foreground tcolor)
  (gimp-layer-set-preserve-trans text-layer TRUE)
  (gimp-edit-fill text-layer FOREGROUND-FILL)
  (cond((= foption 1)
    (gimp-gradients-set-gradient grad)
    (gimp-edit-blend text-layer CUSTOM-MODE NORMAL-MODE gmode 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 width height)
    )
    ((= foption 2)
       (gimp-selection-layer-alpha text-layer)
       (gimp-patterns-set-pattern pat)
       (gimp-edit-bucket-fill text-layer PATTERN-BUCKET-FILL NORMAL-MODE 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))
    (gimp-layer-set-preserve-trans text-layer FALSE)

    (script-fu-mhbumpimg img text-layer size bwidth bblur bb inv noc TRUE)

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mhbump"
		    "<Image>/File/Create/Logos/Bump..."
		    "mhbump"
		    "Kiki"
		    "Kiki"
		    "2005/4"
		    ""
		    SF-STRING     "Text String"        "Bump"
		    SF-ADJUSTMENT "Font Size (pixels)  " '(150 2 1000 1 10 0 1)
		    SF-FONT       "Font"               "Pump Demi Bold LET"
                    SF-OPTION     "fg-mode"            '(_"color" _"gradient" _"pattern")
		    SF-COLOR      "Color"              '(200 224 156)
                    SF-GRADIENT   "Gradient"           "Abstract 3"
                    SF-OPTION     "gradient-mode"      '(_"0(GRADIENT-LINEAR)" _"1" _"2" _"3" _"4" _"5" _"6" _"7" _"8" _"9" _"10")
                    SF-PATTERN    "Pattern"            "Leather"
		    SF-ADJUSTMENT _"bevel-width"       '(10 1 300 1 2 0 0)
		    SF-ADJUSTMENT _"bevel-blur"        '(15 1 100 1 2 0 0)
		    SF-ADJUSTMENT _"bevel"             '(8 1 50 1 2 0 0)
                    SF-TOGGLE     "invert?"             FALSE
                    SF-TOGGLE     "no-color"          FALSE
)



;;mhbumpimg
;Kiki

(define (script-fu-mhbumpimg img drawable size bwidth bblur bb inv noc text?)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))

	 (width (+ width (* bwidth 2)))
	 (height (+ height (* bwidth 2)))

;;wiȂ
	 (w-layer (car (gimp-layer-new img width height RGB-IMAGE "white" 100 NORMAL-MODE)))
	 (p-layer (car (gimp-layer-new img width height RGB-IMAGE "plasma" 100 NORMAL-MODE)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))

;;2.4ǉ
	 (d-layer)
	 (bb-layer)
	 (w2-layer)
	 (ww)
	 (ww2)
	 (bump1)
)
    (gimp-image-undo-group-start img)

    (if (= FALSE text?)
    (begin
	 (set! width (+ width (* bwidth 0.2)))
	 (set! height (+ height (* bwidth 0.2)))
	 (gimp-image-resize img width height (+ bwidth (* bwidth 0.1)) (+ bwidth (* bwidth 0.1)))
	 (gimp-layer-resize drawable width height (+ bwidth (* bwidth 0.1)) (+ bwidth (* bwidth 0.1)))
    )
;;TCY
    (begin
	(gimp-image-resize img width height bwidth bwidth)
	(gimp-layer-resize drawable width height bwidth bwidth)
    ))

    (if (= inv FALSE) (set! inv TRUE)
                      (set! inv FALSE)
    )

    (plug-in-waves 1 img drawable (* (/ size 150) 1.3) 5 (* (/ size 150) 10) 0 0)
    (gimp-selection-layer-alpha drawable)
    (set! d-layer (car (gimp-layer-copy drawable 0)))
    (gimp-image-add-layer img d-layer 1)
    (gimp-palette-set-foreground '(0 0 0))
    (gimp-edit-fill d-layer FOREGROUND-FILL)
    (set! bb-layer (car (gimp-layer-copy d-layer 0)))
    (gimp-selection-grow img bwidth)
    (gimp-selection-feather img bblur)
    (gimp-selection-invert img)
    (gimp-palette-set-foreground '(0 0 0))
    (gimp-edit-fill d-layer FOREGROUND-FILL)
    (gimp-selection-none img)
    (gimp-image-add-layer img w-layer 2)
    (if (= FALSE text?) (gimp-layer-resize w-layer width height 0 0))	;add
    (gimp-palette-set-foreground '(255 255 255))
    (gimp-edit-fill w-layer FOREGROUND-FILL)
    (set! w2-layer (car (gimp-layer-copy w-layer 0)))
    (set! ww (car (gimp-image-merge-down img d-layer 0)))

    (gimp-image-add-layer img p-layer 1)
    (if (= FALSE text?) (gimp-layer-resize p-layer width height 0 0))	;add
    (plug-in-plasma 1 img p-layer 13458 1)
    (gimp-desaturate p-layer)
    (plug-in-bump-map 1 img p-layer ww 135 42 33 0 0 0 0 TRUE 0 0)

    (gimp-image-add-layer img bb-layer 0)
    (gimp-image-add-layer img w2-layer 1)
    (set! ww2 (car (gimp-image-merge-down img bb-layer 0)))
    (plug-in-gauss-iir2 1 img ww2 bb bb)
    (set! bump1 (* (/ size 150) 11))
    (if (< bump1 1) (set! bump1 1))
    (if (> bump1 65) (set! bump1 65))
    (plug-in-bump-map 1 img drawable ww2 123 28 bump1 0 0 0 0 TRUE inv 2)
    (gimp-image-remove-layer img ww)
    (gimp-image-remove-layer img ww2)
    (if (= noc TRUE)
    (begin
        (gimp-image-remove-layer img drawable)
        (gimp-brightness-contrast p-layer 50 35)
    ))

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-group-end img)
    (gimp-displays-flush)
))

(define (script-fu-mhbumpimgh img drawable size bwidth bblur bb inv noc)

    (script-fu-mhbumpimg img drawable size bwidth bblur bb inv noc FALSE)

)

(script-fu-register "script-fu-mhbumpimgh"
		    "<Image>/Script-Fu/MH/bump"
		    "mhbumpimg"
		    "Kiki"
		    "Kiki"
		    "2005/4"
		    "RGBA"
		    SF-IMAGE        "Image"    0
		    SF-DRAWABLE     "Drawable" 0
		    SF-ADJUSTMENT  _"size"		'(150 2 1000 1 10 0 1)
		    SF-ADJUSTMENT  _"bevel-width"	'(10 1 300 1 2 0 0)
		    SF-ADJUSTMENT  _"bevel-blur"	'(15 1 100 1 2 0 0)
		    SF-ADJUSTMENT  _"bevel"		'(8 1 50 1 2 0 0)
                    SF-TOGGLE       "invert?"		FALSE
                    SF-TOGGLE       "no-color"		FALSE
)
