;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Cheesy Text Effect                                                           ;
; Version 1.0                                                                  ;
; Copyright (c) 2004 James Remington                                           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (script-fu-cheesy-effect String Color Font Size Opacity CenterColor Border fromColor toColor outerBorder fromColor2 toColor2 bgColor)
  (let* (
						;add
	(oldFG (car (gimp-palette-get-foreground)))
	(oldBG (car (gimp-palette-get-background)))
	(cnt (car (gimp-palette-set-foreground CenterColor)))		;add
	(tmp1 (car (gimp-palette-set-background '(255 255 255))))	;add
	(Image (car (gimp-image-new 100 100 0)))
	(txtLayer (car (gimp-text-fontname Image -1 0 0 String -1 TRUE Size 1 Font)))
	)						;add

; OLD INFO

(script-fu-cheesy-effectcore Image txtLayer Color Size Opacity CenterColor Border fromColor toColor outerBorder fromColor2 toColor2 bgColor)

; CLEAN UP
(gimp-palette-set-foreground oldFG)
(gimp-palette-set-background oldBG)
(gimp-selection-clear Image)

(gimp-display-new Image)
)		;add let*
)


(script-fu-register "script-fu-cheesy-effect"

	_"<Image>/File/Create/Logos/Cheesy Effect..."
	"A Cheesy Text Effect\nVersion 1.0"
	"James Remington"
	"2004"
	"Sunday, April 25, 2004"
	""
	SF-STRING "Text" "Cheesy Effect"
	SF-COLOR "Font Color" '(255 255 0)
	SF-FONT "Font" "Arial"
	SF-ADJUSTMENT "Font Size" '(100 2 1000 1 10 0 1)
	SF-ADJUSTMENT "Opacity" '(60 0 100 1 10 0 0)
	SF-COLOR "Center Color" '(0 0 0)
	SF-ADJUSTMENT "Iner-Border Width" '(4 1 50 1 10 0 1)
	SF-COLOR "Iner-Border Color 1" '(255 0 0)
	SF-COLOR "Iner-Border Color 2" '(255 150 0)
	SF-ADJUSTMENT "Outer-Border Width" '(2 1 50 1 10 0 1)
	SF-COLOR "Outer-Border Color 1" '(255 150 0)
	SF-COLOR "Outer-Border Color 2" '(255 255 0)
	;SF-TOGGLE "Flatten Image" FALSE
	SF-COLOR "Background Color" '(255 255 255)

)

(define (script-fu-cheesy-effectimg Image txtLayer Color Size Opacity CenterColor Border fromColor toColor outerBorder fromColor2 toColor2 bgColor)
  (let* (
						;add
	(oldFG (car (gimp-palette-get-foreground)))
	(oldBG (car (gimp-palette-get-background)))
	(cnt (car (gimp-palette-set-foreground CenterColor)))		;add
	(tmp1 (car (gimp-palette-set-background '(255 255 255))))	;add
	)

(script-fu-cheesy-effectcore Image txtLayer Color Size Opacity CenterColor Border fromColor toColor outerBorder fromColor2 toColor2 bgColor)

(gimp-palette-set-foreground oldFG)
(gimp-palette-set-background oldBG)
(gimp-selection-clear Image)
  (gimp-displays-flush)
)
)

(script-fu-register "script-fu-cheesy-effectimg"

	_"<Image>/Filters/Alpha to logo/Cheesy Effect..."
	"A Cheesy Text Effect\nVersion 1.0"
	"James Remington"
	"2004"
	"Sunday, April 25, 2004"
	""
	SF-IMAGE       	"Image" 0
	SF-DRAWABLE    	"Drawable" 0
	SF-COLOR "Color" '(255 255 0)
	SF-ADJUSTMENT "Size" '(100 2 1000 1 10 0 1)
	SF-ADJUSTMENT "Opacity" '(60 0 100 1 10 0 0)
	SF-COLOR "Center Color" '(0 0 0)
	SF-ADJUSTMENT "Iner-Border Width" '(4 1 50 1 10 0 1)
	SF-COLOR "Iner-Border Color 1" '(255 0 0)
	SF-COLOR "Iner-Border Color 2" '(255 150 0)
	SF-ADJUSTMENT "Outer-Border Width" '(2 1 50 1 10 0 1)
	SF-COLOR "Outer-Border Color 1" '(255 150 0)
	SF-COLOR "Outer-Border Color 2" '(255 255 0)
	;SF-TOGGLE "Flatten Image" FALSE
	SF-COLOR "Background Color" '(255 255 255)

)

(define (script-fu-cheesy-effectcore Image txtLayer Color Size Opacity CenterColor Border fromColor toColor outerBorder fromColor2 toColor2 bgColor)
  (let* (
						;add
	(oldFG (car (gimp-palette-get-foreground)))
	(oldBG (car (gimp-palette-get-background)))
	(cnt (car (gimp-palette-set-foreground CenterColor)))		;add
	(tmp1 (car (gimp-palette-set-background '(255 255 255))))	;add
	(Height (car (gimp-drawable-height txtLayer)))
	(Width (car (gimp-drawable-width txtLayer)))
	(bgLayer (car (gimp-layer-new Image (+ (+ (/ Size 10) 10) Width Border) (+ (+ (/ Size 10) 10) Height Border) 1 "Iner-Border" 100 0)))
	(bgLayer2 (car (gimp-layer-new Image (+ (+ (/ Size 10) 10) Width Border outerBorder) (+ (+ (/ Size 10) 10) Height Border outerBorder) 1 "Outer-Border" 100 0)))
	(background (car (gimp-layer-new Image (+ (+ (/ Size 10) 10) Width Border outerBorder) (+ (+ (/ Size 10) 10) Height Border outerBorder) 1 "Background" 100 0)))
	)

; NEW INFO
(gimp-palette-set-foreground Color)


(plug-in-autocrop 0 Image txtLayer)
(gimp-layer-set-opacity txtLayer Opacity)

(if (>= Size 100) (gimp-image-resize Image (+ (+ (/ Size 10) 10) Width Border outerBorder) (+ (+ (/ Size 10) 10) Height Border outerBorder) (+ (+ (/ Size 15) 10) (/ (+ Border outerBorder) 2)) (+ (+ (/ Size 15) 10) (/ (+ Border outerBorder) 2)))
       (gimp-image-resize Image (+ (+ (/ Size 10) 10) Width Border outerBorder) (+ (+ (/ Size 10) 10) Height Border outerBorder) (+ (+ (/ Size 20) 7) (/ (+ Border outerBorder) 2)) (+ (+ (/ Size 20) 7) (/ (+ Border outerBorder) 2)))
)


(gimp-image-add-layer Image bgLayer 1)

; CLEAN UP bgLayer
(gimp-selection-all Image)
(gimp-edit-clear bgLayer)
(gimp-selection-clear Image)

(gimp-image-add-layer Image bgLayer2 2)

; CLEAN UP bgLayer2
(gimp-selection-all Image)
(gimp-edit-clear bgLayer2)
(gimp-selection-clear Image)


; LETS CREATE THE INER-BORDER
(gimp-selection-layer-alpha txtLayer)
(gimp-selection-grow Image Border)

(gimp-palette-set-foreground fromColor)
(gimp-palette-set-background toColor)
(gimp-edit-blend bgLayer 0 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 10 0 (- Height 10))

; TIME FOR THE OUTER-BORDER
(gimp-selection-layer-alpha bgLayer)
(gimp-selection-grow Image outerBorder)

(gimp-palette-set-foreground fromColor2)
(gimp-palette-set-background toColor2)
(gimp-edit-blend bgLayer2 0 0 0 100 0 0 FALSE FALSE 0 0 FALSE 0 10 0 (- Height 10))


; FLATTEN IMAGE?
;(if (= Flat 1)(gimp-palette-set-background bgColor))
;(if (= Flat 1)(gimp-image-flatten Image))

;(if (= Flat 2)(gimp-image-merge-visible-layers Image 0))

(gimp-selection-all Image)
(gimp-image-add-layer Image background 3)
(gimp-palette-set-foreground bgColor)
(gimp-edit-fill background FG-IMAGE-FILL)
(gimp-selection-none Image)

)
)
