;;mhdisplace
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhdisplacepro img drawable blur md tcolor text-gradient pat ele depth bump-layer grad-layer height moji)

;add 2.4
  (let (
       (k1 0)
       )

    (set! k1 (car (gimp-image-merge-visible-layers img 0)))
    (plug-in-gauss-iir2 1 img k1 blur blur)
    (gimp-image-add-layer img bump-layer 0)
    (gimp-palette-set-foreground '(152 152 152))
    (gimp-edit-fill bump-layer FOREGROUND-FILL)
    (plug-in-bump-map 1 img bump-layer k1 135 ele depth 0 0 0 0 TRUE TRUE 2)
    (gimp-gradients-set-gradient "Three bars sin")
    (plug-in-gradmap 1 img bump-layer)

    (gimp-image-add-layer img grad-layer 1)
    (gimp-palette-set-foreground tcolor)
    (gimp-edit-fill grad-layer FOREGROUND-FILL)
    (cond((= md 1)
      (gimp-gradients-set-gradient text-gradient)
      (gimp-edit-blend grad-layer CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 0 height))
    ((= md 2)
       (gimp-selection-all img)
       (gimp-patterns-set-pattern pat)
       (gimp-edit-bucket-fill grad-layer PATTERN-BUCKET-FILL NORMAL-MODE 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))

    (plug-in-displace 1 img grad-layer 10 10 TRUE TRUE k1 k1 2)
    (if (= TRUE moji) (gimp-image-remove-layer img k1))

;add 2.4(let)
 )

)

(define (script-fu-mhdisplacebg img drawable bgm bg-color bgg bgp grad-layer height bg)
    (gimp-edit-clear grad-layer)
    (gimp-image-add-layer img bg 2)
    (gimp-selection-all img)
    (gimp-palette-set-foreground bg-color)
    (gimp-drawable-fill bg FOREGROUND-FILL)
    (cond((= bgm 1)
       (gimp-gradients-set-gradient bgg)
       (gimp-edit-blend bg CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 0 height))
    ((= bgm 2)
       (gimp-patterns-set-pattern bgp)
       (gimp-edit-bucket-fill bg PATTERN-BUCKET-FILL NORMAL-MODE 100 255 FALSE 0 0)
       ))
    (gimp-selection-none img)
)



(define (script-fu-mhdisplace text size font blur md tcolor text-gradient pat ele depth opa bg? bgm bg-color bgg bgp ft?)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
;;text
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 12) 4) TRUE size PIXELS font)))
;;width height
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))
;;background etc..
	 (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "BG" 100 NORMAL-MODE)))
	 (bump-layer (car (gimp-layer-new img width height RGBA-IMAGE "Bump" 100 NORMAL-MODE)))
	 (grad-layer (car (gimp-layer-new img width height RGBA-IMAGE "Grad" 100 NORMAL-MODE)))
	 (bg (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 NORMAL-MODE)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))

;;add 2.4
	 (tt 0)
)
(gimp-image-undo-disable img)
;;resize
    (gimp-image-resize img width height 0 0)

;;black text
    (gimp-palette-set-foreground '(0 0 0))
    (gimp-layer-set-preserve-trans text-layer TRUE)
    (gimp-edit-fill text-layer FOREGROUND-FILL)
;;white background
    (gimp-palette-set-foreground '(255 255 255))
    (gimp-image-add-layer img bg-layer 1)
    (gimp-drawable-fill bg-layer FOREGROUND-FILL)

    (set! tt (car (gimp-layer-copy text-layer 0)))

    (script-fu-mhdisplacepro img text-layer blur md tcolor text-gradient pat ele depth bump-layer grad-layer height 1)

    (gimp-image-add-layer img tt 0)		;add 2.8

    (gimp-selection-layer-alpha tt)
    (gimp-selection-grow img 5)
    (gimp-selection-invert img)
    (gimp-selection-feather img 3)
    (gimp-edit-clear bump-layer)

    (gimp-image-remove-layer img tt)		;add 2.8

    (gimp-layer-set-mode bump-layer 5)
    (gimp-layer-set-opacity grad-layer opa)

    (if (= bg? TRUE)
	(script-fu-mhdisplacebg img text-layer bgm bg-color bgg bgp grad-layer height bg)
	(gimp-layer-set-opacity grad-layer 100)
    )

    (if (= ft? TRUE)
    (gimp-image-flatten img)
    )

    (gimp-selection-none img)
    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mhdisplace"
		    "<Image>/File/Create/Logos/Displace..."
		    "mhdisplace"
		    "Kiki"
		    "Kiki"
		    "2005/2"
		    ""
		    SF-STRING     "Text String"      "Displace"
		    SF-ADJUSTMENT "Font Size (pixels)" '(100 2 1000 1 10 0 1)
		    SF-FONT       "Font"             "SaloonExt"
		    SF-ADJUSTMENT "blur"             '(15 1 100 1 10 2 0)
                    SF-OPTION     "mode"             '(_"color" _"grad" _"pattern")
                    SF-COLOR      "Text Color"       '(150 180 255)
                    SF-GRADIENT   "Gradient"         "Horizon 2"
                    SF-PATTERN    "Pattern"          "Fibers"
		    SF-ADJUSTMENT "Elevation"        '(27 1 90 1 10 0 1)
		    SF-ADJUSTMENT "Depth"            '(7 1 65 1 10 0 1)
		    SF-ADJUSTMENT "Opacity"          '(80 1 100 1 10 2 0)
                    SF-TOGGLE     "bg?"               TRUE
                    SF-OPTION     "bg mode"          '(_"color" _"grad" _"pattern")
		    SF-COLOR      "Background Color" '(222 233 255)
                    SF-GRADIENT   "Background Gradient"     "Horizon 1"
                    SF-PATTERN    "Background Pattern"      "Pastel Stuff"
                    SF-TOGGLE     "Flatten Image"          TRUE)


;;mhdisplaceimg
;Kiki

(define (script-fu-mhdisplaceimg img drawable blur md tcolor text-gradient pat ele depth opa bg? bgm bg-color bgg bgp ft?)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
;;wiȂǂ̃C[
	 (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "BG" 100 NORMAL-MODE)))
	 (bump-layer (car (gimp-layer-new img width height RGBA-IMAGE "Bump" 100 NORMAL-MODE)))
	 (grad-layer (car (gimp-layer-new img width height RGBA-IMAGE "Grad" 100 NORMAL-MODE)))
	 (bg (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 NORMAL-MODE)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))

;;2.4ǉ
	 (aa 0)
	 (tt 0)
)
    (gimp-image-undo-group-start img)

    (set! aa (car (gimp-drawable-has-alpha drawable)))
    (gimp-image-add-layer img bg-layer 1)
    (gimp-edit-clear bg-layer)
    (if (= TRUE aa)
    (begin
    (set! tt (car (gimp-layer-copy drawable 0)))
    (gimp-palette-set-foreground '(255 255 255))
    (gimp-drawable-fill bg-layer FOREGROUND-FILL)
    ))

    (script-fu-mhdisplacepro img drawable blur md tcolor text-gradient pat ele depth bump-layer grad-layer height 0)

    (if (= TRUE aa)
    (begin
    (gimp-selection-layer-alpha tt)
    (gimp-selection-grow img 5)
    (gimp-selection-invert img)
    (gimp-selection-feather img 3)
    (gimp-edit-clear bump-layer)
    ))
    (gimp-layer-set-mode bump-layer 5)
    (gimp-layer-set-opacity grad-layer opa)

    (if (and (= bg? TRUE) (= TRUE aa))
      (script-fu-mhdisplacebg img drawable bgm bg-color bgg bgp grad-layer height bg)
    )

    (if (= ft? TRUE)
    (gimp-image-flatten img)
    )

    (gimp-selection-none img)
    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-group-end img)
    (gimp-displays-flush)
))

(script-fu-register "script-fu-mhdisplaceimg"
		    "<Image>/Script-Fu/MH/displace"
		    "mhdisplaceimg"
		    "Kiki"
		    "Kiki"
		    "2005/2"
		    "RGB*"
		    SF-IMAGE        "Image"		0
		    SF-DRAWABLE     "Drawable"		0
		    SF-ADJUSTMENT "blur"		'(5 1 100 1 10 2 0)
                    SF-OPTION     "mode"		'(_"color" _"grad" _"pattern")
                    SF-COLOR      "Color"		'(150 180 255)
                    SF-GRADIENT   "Gradient"		"Horizon 2"
                    SF-PATTERN    "Pattern"		"Fibers"
		    SF-ADJUSTMENT "Elevation"		'(27 1 90 1 10 0 1)
		    SF-ADJUSTMENT "Depth"		'(7 1 65 1 10 0 1)
		    SF-ADJUSTMENT "Opacity"		'(80 1 100 1 10 2 0)
                    SF-TOGGLE     "bg?"			TRUE
                    SF-OPTION     "bg mode"		'(_"color" _"grad" _"pattern")
		    SF-COLOR      "Background Color"	'(222 233 255)
                    SF-GRADIENT   "Background Gradient"	"Horizon 1"
                    SF-PATTERN    "Background Pattern"	"Pastel Stuff"
                    SF-TOGGLE     "Flatten Image"	TRUE)

