

;
; With apple-oggies to the Prodigy.
; Christopher Gutteridge (cjg@ecs.soton.ac.uk)
;


; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


; Define the function:

(define (script-fu-experience-logo inText inFont inFontSize tcolor bcolor tbrush tgrow inTrans)

;2.4ǉ
  (let (
       (theImageWidth 0)
       (theImageHeight 0)
       (theBufferAmount 0)
       (theImage 0)
       (theLayer 0)
       (theText 0)
       (theBuffer 0)
       (theBG 0)
	(old-fg (car (gimp-palette-get-foreground)))	;add
	(old-bg (car (gimp-palette-get-background)))	;add
	(old-brush (car (gimp-brushes-get-brush)))
       )

	(gimp-palette-set-foreground tcolor)		;add
	(gimp-palette-set-background bcolor)		;add
              (set! theImageWidth 10)
              (set! theImageHeight 10)
	      (set! theBufferAmount 20)

              (set! theImage (car (gimp-image-new theImageWidth theImageHeight RGB) ) )


          (set! theLayer (car (gimp-layer-new theImage theImageWidth theImageHeight RGBA-IMAGE inText 100 NORMAL-MODE) ) )
          (gimp-image-add-layer theImage theLayer 0)


          (gimp-selection-all theImage)
          (gimp-edit-clear theLayer)
          (gimp-selection-none theImage)
          (set! theText (car (gimp-text theImage theLayer 0 0 inText 0 TRUE ( * 2 inFontSize) PIXELS "*" inFont "*" "r" "*" "*" "*" "*")))
          (set! theImageWidth  (car (gimp-drawable-width  theText) ) )
          (set! theImageHeight (car (gimp-drawable-height theText) ) )

          (set! theBuffer (* theImageHeight (/ theBufferAmount 100) ) )
          (set! theImageHeight (+ theImageHeight theBuffer theBuffer) )
          (set! theImageWidth  (+ theImageWidth  theBuffer theBuffer) )
          (gimp-layer-set-offsets theText theBuffer theBuffer)

          (gimp-image-resize theImage theImageWidth theImageHeight 0 0)
          (gimp-layer-resize theLayer theImageWidth theImageHeight 0 0)
	  (gimp-floating-sel-anchor theText)
	  (gimp-selection-layer-alpha theLayer)

          (gimp-edit-clear theLayer)
          (gimp-selection-grow theImage tgrow)		;changed
	  (gimp-brushes-set-brush (car tbrush))		;changed
	  (gimp-edit-stroke theLayer)
          (gimp-selection-shrink theImage (* 2 tgrow))	;changed
	  (gimp-palette-swap-colors)
	  (gimp-edit-fill theLayer BACKGROUND-FILL)
	  (gimp-palette-swap-colors)

	  (if (= inTrans FALSE) 
              (begin 
                  (set! theBG (car (gimp-layer-new theImage theImageWidth theImageHeight RGB-IMAGE inText 100 NORMAL-MODE) ) )
                  (gimp-image-add-layer theImage theBG 1)
                  (gimp-selection-all theImage)
                  (gimp-drawable-fill theBG BACKGROUND-FILL)
	  	  (gimp-image-flatten theImage)
              )
	      ()
          )
          (gimp-selection-none theImage)
	  (gimp-image-scale theImage (/ theImageWidth 2) (/ theImageHeight 2))

	(gimp-palette-set-foreground old-fg)	;add
	(gimp-palette-set-background old-bg)	;add
	(gimp-brushes-set-brush old-brush)	;add

          (gimp-display-new theImage)
	  (gimp-displays-flush)

;;2.4ǉ(let)
  )

)


; Register the function with the GIMP:

(script-fu-register
    "script-fu-experience-logo"
    "<Image>/File/Create/Logos/Experience..."
    "Creates a Prodigy Experience Album Cover kinda affair. Colours taken from current FG and BG."
    "Christopher Gutteridge"
    "1997, Christopher Gutteridge"
    "May 12, 1998"
    ""
    SF-STRING		"Text"		"pRodiGY"
    SF-FONT		"Font"		"Charter"
    SF-ADJUSTMENT	"Font Size"	'(90 2 1000 1 10 0 1)
    SF-COLOR  "Text Color"		'(0 0 0)
    SF-COLOR  "Background Color"	'(255 255 255)
    SF-BRUSH      "Use Brush"        '("Circle (05)" 1.0 20 0)
    SF-ADJUSTMENT	"Grow size"	'(4 1 50 1 10 0 1)
    SF-TOGGLE "Transparent Background?"	FALSE
)
