; Fiery Beveled Text
; Script-Fu for GIMP 2.6 , by LightningIsMyName
; 
; This script makes a beveled text logo with flames
; 
; This script was written by LightningIsMyName
; Email: lightningismyname(at)gmail(dot)com 
; My Home Page: http://lightningismyname.deviantart.com/
;
; This Program is a free software, and you may use it for any purpose, comercial and non-commercial.
; You may not sell or redistribute this software alone or inside a bundle unless it's for FREE.
; You may modify this script only if:
; 1. You keep this message with my email, homepage, description, and release log.
; 2. You share alike with the same licensing, and without any profit.
;
; This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
; even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; 
; Release Log: Version 1.0 - December 2007
;              Initial public release, for GIMP 2.4
;
;              Version 1.1 - February 2009
;              Another public release, for GIMP 2.6.
;              Updated the let* syntax so it will also work on GIMP 2.6
;              Updated the menu registration of the script


;Tosilscript-fugp܂B
;http://www.geocities.jp/gimproject/scripts/layers-view-delete.html

(define (script-fu-layers-view-none image drawable)
 (let* ((layers (gimp-image-get-layers image))
	    (number-layers (car layers))
	    (layer-array (cadr layers))
	    (layer-count 0)
	    (layer))
    (set! layer-count 0)
    (while (< layer-count number-layers)
           (set! layer (aref layer-array layer-count))
           (gimp-drawable-set-visible layer FALSE)
           (set! layer-count (+ layer-count 1)))
))
(define (script-fu-layers-view-current-only image drawable)
    (script-fu-layers-view-none image drawable)
    (if (not (= 0 (car (gimp-drawable-is-layer drawable))))
        (gimp-drawable-set-visible drawable TRUE))
)

(define (script-fu-logos-beveledfire string font size color gradient merge)
  
  (let*
      (
	(old-fg-color (car (gimp-palette-get-foreground)))
	(old-bg-color (car (gimp-palette-get-background)))
	(old-grad (car (gimp-gradients-get-gradient)))
	(old-pat (car (gimp-patterns-get-pattern)))
	(tmp (car (gimp-palette-set-foreground '(0 0 0))))		;add
	(tmp1 (car (gimp-palette-set-background '(255 255 255))))	;add
       (img (car
             (gimp-image-new 1 1 RGB)))
       
       (text (car 
              (gimp-text-fontname img -1 0 0 string (+ (/ size 10) 4) TRUE size 0 font)))
       
       (width (car 
               (gimp-drawable-width text)))
       
       (height (car 
                (gimp-drawable-height text)))
       (pattern 0)
       
       (hardlight 0)
       
       (displace 0)
       
       (colorify 0)
       
       (fire 0)
       
       (paste 0)

	(tmp-layer 0) (radius 0)			;add 2.2
       )
    
    (set! width (+ 50 width))
    
    (set! height (+ 50 height))
    
    (gimp-image-resize img width height 25 25)
    (gimp-layer-resize text width height 25 25)		;add
    (gimp-display-new img)

(script-fu-logos-beveledfirecore img text size color gradient merge)

    (gimp-palette-set-foreground old-fg-color)
    (gimp-palette-set-background old-bg-color)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)
    (gimp-displays-flush)
    
    )
  )

(script-fu-register
 "script-fu-logos-beveledfire"
 "<Image>/File/Create/Logos/FieryBeveled Flaming Text..."
 "Make a beveled fiery logo"
 "LightningIsMyName (LIMN)"
 "LightningIsMyName (LIMN)"
 "December 2007"
 ""
 
 SF-STRING	"Your Text:"         								"I'm On Fire!"
 SF-FONT		"Font (Diffrent kinds of fonts give different beveling)"    			"Script MT Bold, Bold"
 SF-ADJUSTMENT	"Font size - pixels (better results with big text so do big and resize later)"	'(100 2 1000 1 10 0 1)
 SF-COLOR	"Base Color:"        								'(255 0 0)
 SF-GRADIENT	"Gradient (select a pattern that matches your color)"				"German flag smooth"
 SF-TOGGLE 	"Merge all layers when done" FALSE
 
 )


(define (script-fu-logos-beveledfireimg img drawable size color gradient merge)
  
  (let*
      (
	(old-fg-color (car (gimp-palette-get-foreground)))
	(old-bg-color (car (gimp-palette-get-background)))
	(old-grad (car (gimp-gradients-get-gradient)))
	(old-pat (car (gimp-patterns-get-pattern)))
	(tmp (car (gimp-palette-set-foreground '(0 0 0))))		;add
	(tmp1 (car (gimp-palette-set-background '(255 255 255))))	;add
       (width (car (gimp-drawable-width drawable)))
       (height (car (gimp-drawable-height drawable)))
    )

(gimp-image-undo-group-start img)

    (script-fu-layers-view-current-only img drawable)	;Tosilscript-fu

    (set! width (+ 50 width))
    (set! height (+ 50 height))
    (gimp-image-resize img width height 25 25)
    (gimp-layer-resize drawable width height 25 25)		;add

(script-fu-logos-beveledfirecore img drawable size color gradient merge)

    (gimp-palette-set-foreground old-fg-color)
    (gimp-palette-set-background old-bg-color)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

(gimp-undo-push-group-end img)
    (gimp-displays-flush)
)
)

(script-fu-register
 "script-fu-logos-beveledfireimg"
 "<Image>/Filters/Alpha to Logo/FieryBeveled Flaming..."
 "Make a beveled fiery logo"
 "LightningIsMyName (LIMN)"
 "LightningIsMyName (LIMN)"
 "December 2007"
 "RGBA"
 
  SF-IMAGE      "image"      0
  SF-DRAWABLE   "drawable"   0
 SF-ADJUSTMENT	"Size - pixels"			'(100 2 1000 1 10 0 1)
 SF-COLOR	"Base Color:"			'(255 0 0)
 SF-GRADIENT	"Gradient (select a pattern that matches your color)"	"German flag smooth"
 SF-TOGGLE 	"Merge all layers when done"	FALSE
 )


(define (script-fu-logos-beveledfirecore img text size color gradient merge)
  
  (let*
      (
       (width (car 
               (gimp-drawable-width text)))
       
       (height (car 
                (gimp-drawable-height text)))
       (pattern 0)
       
       (hardlight 0)
       
       (displace 0)
       
       (colorify 0)
       
       (fire 0)
       
       (paste 0)

	(tmp-layer 0) (radius 0)			;add 2.2
    )

    (gimp-layer-resize-to-image-size text)
    
    (gimp-selection-layer-alpha text)
    
    (gimp-gradients-set-gradient "Incandescent")
    
    (gimp-edit-blend text 3 0 7 100 0 0 TRUE FALSE 1 0 TRUE 0 0 1 1)
    
    (gimp-selection-none img)
    
;;;    (plug-in-neon 1 img text 5 0)
    (plug-in-edge 2.0 img text 1 0 0)	;change 2.0
(set! tmp-layer (car (gimp-layer-copy text TRUE)))	;add 2.2
(gimp-image-add-layer img tmp-layer -1)			;add 2.2
(gimp-selection-layer-alpha tmp-layer)			;add 2.2
(gimp-palette-set-foreground '(255 255 255))		;add 2.2
(gimp-edit-fill tmp-layer FG-IMAGE-FILL)		;add 2.2
(gimp-selection-none img)				;add 2.2
(set! radius (* (/ size 100) 5))			;add 2.2
(if (> 1 radius) (set! radius 1))			;add 2.2
(plug-in-gauss-iir 1 img tmp-layer radius TRUE TRUE)	;add 2.2
(if (>= (* (/ size 100) 3) 1) (plug-in-bump-map 1 img text tmp-layer 135 (* (/ 100 size) 3) (* (/ size 100) 3) 0 0 0 0 TRUE TRUE 0))	;add 2.2
(gimp-image-remove-layer img tmp-layer)			;add 2.2

    (gimp-gradients-set-gradient "Flare Sizefac 101")
    
    (plug-in-gradmap 1 img text)
    
    (set! colorify (car(gimp-layer-new-from-drawable text img)))
    
    (gimp-image-add-layer img colorify -1)
    
    (plug-in-colorify 1 img colorify color)
    
    (gimp-layer-set-mode colorify 19)
    
    (gimp-selection-layer-alpha colorify)
    
    (set! pattern (car(gimp-layer-new img width height RGB "Pattern" 100 21)))
    
    (gimp-image-add-layer img pattern -1)
    
    (gimp-selection-none img)
    
    (gimp-layer-add-alpha pattern)
    
    (gimp-edit-clear pattern)
    
    (gimp-patterns-set-pattern "Amethyst")
    
    (gimp-selection-layer-alpha colorify)

    (gimp-selection-none img)
    (gimp-edit-bucket-fill pattern 2 0 100 255 FALSE 0 0)
    
    (plug-in-gauss 1 img pattern 6 6 0)
    
    (gimp-edit-copy-visible img)
    
    (set! hardlight(car(gimp-layer-new img width height RGB "HardLight" 100 18)))
    
    (gimp-image-add-layer img hardlight -1)
    
    (gimp-layer-add-alpha hardlight)
    
    (gimp-edit-clear hardlight)
    
    (set! paste (car(gimp-edit-paste hardlight TRUE)))
    
    (gimp-floating-sel-anchor paste)
    
    (gimp-gradients-set-gradient gradient)
    
    (plug-in-gradmap 1 img hardlight)
    
    (set! displace (car(gimp-layer-new img width height RGB "Displace" 100 0)))
    
    (gimp-image-add-layer img displace -1)
    
    (gimp-patterns-set-pattern "Amethyst")
    
    (gimp-selection-all img)
    
    (gimp-edit-bucket-fill displace 2 0 100 255 FALSE 0 0)
    
    (plug-in-gauss 1 img displace 6 6 0)

    (gimp-drawable-set-visible displace FALSE)
    
    (gimp-edit-copy-visible img)
    
    (set! fire(car(gimp-layer-new img width height RGB "FIRE" 100 18)))
    
    (gimp-image-add-layer img fire 5)
    
    (gimp-layer-add-alpha fire)
    
    (gimp-edit-clear fire)
    (gimp-drawable-fill fire TRANS-IMAGE-FILL)		;add    remove noise
    (set! paste (car(gimp-edit-paste fire TRUE)))
    
    (gimp-floating-sel-anchor paste)
    
    (plug-in-warp 1 img fire 20 displace 10 0 90 1 displace FALSE 1 displace 0 displace 0 0)
    
    (gimp-image-remove-layer img displace)
    
;;;    (gimp-curves-spline fire 4 8 #(0 0 101 59 137 197 255 255))	;making flames more solid
    
    (if (= merge 1)
        (gimp-image-merge-visible-layers img 1) )
    (gimp-selection-none img)

)
)
