; Gmic Logos rel 1.1
; Created by Graechan using a layout by MareoQ
; You will need to install GMIC to run this Scipt
; GMIC can be downloaded from http://sourceforge.net/projects/gmic/files/ 
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.00 - Initial Beta Release
; update 1 - Added additional frames
; update 2 - Added additional effects 'Cartoon + Custom Gradient' and 'Fractalize', changed Frames Fuzzy and Simple to gimp for easier to control Frame sizes
; update 3 - Added additional effects "Turbulent Stencil" "Wild Cactus" "Corroded"
; Rel 1 - Initial Release
; Rel 1.1 - Added effects "Relief Light + Hair lock" "Hallucinogenic" "Graffiti" "Ripple"
;
; Include layer Procedure
(define (include-layer image newlayer oldlayer stack)	;stack 0=above 1=below
	(cond ((defined? 'gimp-image-get-item-position) ;test for 2.8 compatability
            (gimp-image-insert-layer image newlayer (car (gimp-item-get-parent oldlayer)) 
			(+ (car (gimp-image-get-layer-position image oldlayer)) stack))                                     ;For GIMP 2.8 
          )
          (else
           (gimp-image-add-layer image newlayer (+ (car (gimp-image-get-layer-position image oldlayer)) stack)) ;For GIMP 2.6 
          )
    ) ;end cond
) ;end add layer procedure
;
(define (script-fu-gmic-logos 
                                      
                                      text
									  justify
									  letter-spacing
									  line-spacing
									  margin
                                      font-in 
                                      font-size
									  color
                                      opacity
									  gmic
									  deform
									  frame
									  frame-color
									  custom-color
									  frame-size
									  flatten
							          )

;*******************************************************conditional start
(let ((handler (car (gimp-message-get-handler))))
	(gimp-message-set-handler 0) ;{ MESSAGE-BOX (0), CONSOLE (1), ERROR-CONSOLE (2) }
	(cond ((not (defined? 'plug-in-gmic)) 
	(gimp-message "You will need to Install\nthe Plugin Gmic to use this script\nto Install Gmic go to this Link\nhttp://sourceforge.net/projects/gmic/files/")
	(gimp-message-set-handler handler))
    (else
    (gimp-message-set-handler handler)	
	
;	("Cartoon + Rodilius" "Deform" "Crayon + Hair lock" "Deform + Hair lock" "Cartoon + Custom Gradient" "Fractalize")
	(gimp-context-push)
	(cond ((= gmic 5) (gimp-context-set-foreground '(255 255 255)))
	(else (gimp-context-set-foreground color)))
	
  (let* (
         (width 100)
         (height 100)
         (offx 0)
         (offy 0)
         (image (car (gimp-image-new width height RGB)))
         (area (* 1000 1000))
         (margin (cond ((= margin -1) (/ font-size 4))
		         (else margin)))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (text-layer (car (gimp-text-fontname image -1 0 0 text margin TRUE font-size PIXELS font)))
         (justify (cond ((= justify 0) 2)
		                ((= justify 1) 0)
						((= justify 2) 1)))
		 (bkg-layer 0)
		 (gmic-layer 0)
		 (frame-layer 0)
		 (average-color 0)
		 (red (car color))	
         (green (cadr color))
		 (blue (caddr color))
		 (f-color 0)
		 (f-red 0)	
         (f-green 0)
		 (f-blue 0)
         (ver 2.8)         
         )
	(cond ((not (defined? 'gimp-image-get-item-position)) (set! ver 2.6))) ;define the gimp version	 
		 
    
	(gimp-context-set-paint-method "gimp-paintbrush")
	(if (= ver 2.8) (gimp-context-set-dynamics "Dynamics Off"))
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
;;;;adjust text 
	(gimp-text-layer-set-justification text-layer justify)
	(gimp-text-layer-set-letter-spacing text-layer letter-spacing)
	(gimp-text-layer-set-line-spacing text-layer line-spacing)
;;;;set the new width and height	
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))


;;;;resize the image	
	(gimp-image-resize image width height 0 0)



;;;;start of script****************************************************************************Darken Text
    (set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" opacity NORMAL-MODE)))
	(include-layer image bkg-layer text-layer 0)	;stack 0=above 1=below
	(gimp-context-set-background '(0 0 0))
	(gimp-drawable-fill bkg-layer BACKGROUND-FILL)
	(set! text-layer (car (gimp-image-merge-down image bkg-layer  CLIP-TO-IMAGE)))
	
;;********************************************************************************************** create the gmic layer
	(set! gmic-layer (car (gimp-layer-copy text-layer TRUE)))
	(include-layer image gmic-layer text-layer 0)	;stack 0=above 1=below               
	(gimp-drawable-set-name gmic-layer "Effect GMIC")
	
    (gimp-image-undo-group-start image)	
    (cond
; *******************************************"Cartoon + Rodilius"
	((= gmic 0)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-cartoon 3,200,20,0.25,1.5,8,0")						
				)

                (plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_rodilius 10,10,300,5,30,0,1,0,0")						
				)				
    )	
; *******************************************"Deform"
	((= gmic 1)
               
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-deform "
						(number->string deform) ",")
				)
				
    )	
; *******************************************"Crayon + Hair lock"
	((= gmic 2)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_crayongraffiti2 300,50,1,0.4,12,1,2,2,0")						
				)

                (plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gtutor_hairlock 0.5,0.5,0.5,"
						(number->string red) ","
						(number->string green) ","
						(number->string blue) ",255,0.5,45,0.5,0.5,0")
				)				
    )
; *******************************************"Deform + Hair lock"
	((= gmic 3)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-deform "
						(number->string deform) ",")
				)

                (plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gtutor_hairlock 0.5,0.5,0.5,"
						(number->string red) ","
						(number->string green) ","
						(number->string blue) ",255,0.5,45,0.5,0.5,0")
				)				
    )
 ;***************************************************************************Relief Light + Hair lock
    ((= gmic 4)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_light_relief 0.3,0.2,0.2,0,1,0.5,0.5,5,0.5,0,0")
													
				)
				
				
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gtutor_hairlock 0.5,0.5,0.5,"
						(number->string red) ","
						(number->string green) ","
						(number->string blue) ",255,0.5,45,0.5,0.5,0")
				)
	
	)   
; *******************************************"Custom Gradient"
	((= gmic 5)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-cartoon 3,200,20,0.25,1.5,8,0")						
				)

                (plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_custom_gradient 0,0,0,1,4,1,0,128,100,100,2,0,1,0,"",1,0,"						
						(number->string red) ","
						(number->string green) ","
						(number->string blue) ",255,255,0,0,255,255,255,0,255,255,255,255,0,0,255,255,255,0,255,0,255,0,0,255,255,128,128,128,255,255,0,255,255,0,0,0,0")				
				
				)				
    )	
;*****************************************************************************Fractalize
    ((= gmic 6)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-fractalize 0.6")
													
				)
				
    )
;***********************************************************************Turbulent Stencil
    ((= gmic 7)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_metallicstencils 0,0")
													
				)
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_turbulence 128,6,4,0,0")
                )
	
	)	
;***************************************************************************Wild Cactus
    ((= gmic 8)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_textured_glass 40,40,1,1,0,2,0,0")
													
				)
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-samj_CeKoaSa_007 1.20,0,10,10,300,10,30,0,0")
                )
	
	)	
;*********************************************************************Corroded
    ((= gmic 9)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_textured_glass 40,40,1,1,0,2,0,0")
													
				)
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_light_relief 0.3,0.2,0.2,0,1,0.5,0.5,5,0.5,0,0")
                )
	
	)	
;***********************************************************************Text in the Mist
    ((= gmic 10)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_extrude3d 100,512,0.6,"
						(number->string width) ","
						(number->string height) ",0.9,25,0,0,45,0,0,-100,0.5,0.7,5,1")													
				)
				
				(set! gmic-layer (car (gimp-image-get-active-layer image)))
				(gimp-drawable-set-name gmic-layer "Effect GMIC")
				(plug-in-colorify RUN-NONINTERACTIVE image gmic-layer color)
				(gimp-layer-resize-to-image-size gmic-layer)
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_lightglow 30,0.5,8,0.8,0,0")
                )
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-jeje_clouds 100,0.94")
                )				
	
	)	
;***********************************************************************Hallucinogenic
    ((= gmic 11)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_fire_edges 3,0.642157,5,25,1,20,0,0")
													
				)
				
				(plug-in-colorify RUN-NONINTERACTIVE image gmic-layer color)
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-samj_Formes_Couleurs_Variees_Dans_Image 0,0,0,0,0,192,128,64,255,1,1,1,1,4,127,255,1,0,0,0,1")
                )
	
	)	
;************************************************************************Graffiti
    ((= gmic 12)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_skeleton 1,0,0,1,0")
													
				)
				
				
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_crayongraffiti2 300,50,1,0.4,12,1,2,2,0")
                )
	            
				(plug-in-colorify RUN-NONINTERACTIVE image gmic-layer color)
				
	)	
;***************************************************************************Ripple
((= gmic 13)

				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_light_relief 0.3,0.2,0.2,0,1,0.5,0.5,5,0.5,0,0")
													
				)
				
				
				
				(plug-in-gmic 1 image gmic-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-ripple 10,20,2,0,0")
                )
	
	)
;**********************************************************************	
	) ;endcond	
; *******************************************	
	
;;;;create the frames
    (set! average-color (car (gimp-image-pick-color image
                       gmic-layer
                       (/ width 2)
                       (/ height 2)
                       TRUE
                       TRUE
                       (/ (sqrt (+ (expt width 2)
                                   (expt height 2) ))
                          2 ))))
	(set! f-color (cond ((= frame-color 0) custom-color)
	                    ((= frame-color 1) average-color)
						((= frame-color 2) '(0 0 0))
						((= frame-color 3) '(255 255 255))
						((= frame-color 4) '(255 255 210))
						((= frame-color 5) '(200 200 200))))
	
	(set! f-red (car f-color))	
    (set! f-green (cadr f-color))
	(set! f-blue (caddr f-color))					  
	
	(cond
;***************************************************************************************Frame Fuzzy	
    ((= frame 1)

	   (script-fu-fuzzy-border 
	                        image ;inImage
                            gmic-layer ;inLayer
                            f-color ;inColor
                            frame-size ;inSize
                            TRUE ;inBlur
                            4    ;inGranu
                            FALSE ;inShadow
                            100 ;inShadWeight
                            FALSE ;inCopy
                            FALSE ;inFlatten
        )
		
		(set! frame-layer (car(gimp-image-get-layer-by-name image "layer 1")))
		(gimp-drawable-set-name frame-layer "Frame Fuzzy")
	
	)
;***********************************************************************************Frame Simple
    ((= frame 2)
    
        (script-fu-addborder image gmic-layer 2 2 '(255 255 255) 1)
		
		(set! frame-layer (car(gimp-image-get-layer-by-name image "Border Layer")))
		(gimp-drawable-set-name frame-layer "Frame Simple")
		
		(script-fu-addborder 
		                    image ; aimg 
							frame-layer ; adraw 
							frame-size ; xsize 
							frame-size ; ysize 
							f-color ; colour 
							45 ; dvalue
		)
				
        (set! bkg-layer (car(gimp-image-get-layer-by-name image "Border Layer")))
		(set! frame-layer (car (gimp-image-merge-down image bkg-layer EXPAND-AS-NECESSARY)))
		(gimp-drawable-set-name frame-layer "Frame Simple")
	
    )
;*************************************************************************************Frame Picture
    ((= frame 3)

	(set! frame-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
	(include-layer image frame-layer gmic-layer 0)	;stack 0=above 1=below
	
				(plug-in-gmic 1 image frame-layer 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_frame_painting "
						(number->string (/ frame-size 4)) ",0.4,1.5,"
						(number->string f-red) ","
						(number->string f-green) ","
						(number->string f-blue) ",0,400,100,70.6161,6.25592,0.5,123456,0")
						 
                )

    (set! frame-layer (car (gimp-image-get-active-layer image)))
	(gimp-drawable-set-name frame-layer "Frame Picture")
	
    )
;**************************************************************************************
	) ;endcond
	
	
	
	
	
    (gimp-drawable-set-name gmic-layer "Effect GMIC")
	
;;;;centre the existing layers 	
    (set! offx (/ (- (car (gimp-image-width image)) (car (gimp-drawable-width text-layer))) 2))
    (set! offy (/ (- (car (gimp-image-height image)) (car (gimp-drawable-height text-layer))) 2))    
    (gimp-layer-set-offsets text-layer offx offy)
	(gimp-layer-set-offsets gmic-layer offx offy)
	
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
	(include-layer image bkg-layer text-layer 0)	;stack 0=above 1=below
	(gimp-context-set-background '(0 0 0))
	(gimp-drawable-fill bkg-layer BACKGROUND-FILL)
	(gimp-layer-set-offsets bkg-layer offx offy)
	
	(if (= flatten TRUE) (gimp-image-flatten image))
	
;;;;end of script;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
    
	(gimp-image-undo-group-end image)
	(gimp-context-pop)
    (gimp-display-new image)
	
    ) ;end main variables
	
	) ;endelse	
	) ;endcond
	) ;end conditional start
  ) ;end procedure
  
(script-fu-register "script-fu-gmic-logos"
  "Gmic Logos..."
  "Create various logos with optional frames using Gimp & Gmic"
  "Graechan, MareoQ"
  "Graechan - http://gimpchat.com"
  "Dec 2014"
  ""
  
  SF-TEXT       "Text"    "GMIC LOGO"
  SF-OPTION "Justify" '("Centered" "Left" "Right")
  SF-ADJUSTMENT "Letter Spacing" '(0 -100 100 1 5 0 0)
  SF-ADJUSTMENT "Line Spacing" '(0 -100 100 1 5 0 0)
  SF-ADJUSTMENT "Add Margin[-1= autosize]" '(50 -1 200 1 10 0 0)
  SF-FONT       "Font"               "Arial"
  SF-ADJUSTMENT "Font size (pixels)" '(150 6 500 1 1 0 1)
  SF-COLOR      "Text color"         '(255 255 0)
  SF-ADJUSTMENT "Darken Text Amt" '(50 0 100 1 10 0 0)
  SF-OPTION     "Gmic" '("Cartoon + Rodilius" "Deformation" "Crayon + Hair lock" "Deform + Hair lock" "Relief Light + Hair lock" "Custom Gradient" "Fractalize" 
  "Turbulent Stencil" "Wild Cactus" "Corroded" "Text in the Mist" "Hallucinogenic" "Graffiti" "Ripple")
  SF-ADJUSTMENT "Deform Amt" '(5 0 100 1 5 0 0)
  SF-OPTION     "Frame" '("None" "Frame Fuzzy" "Frame Simple" "Frame Picture")
  SF-OPTION     "Frame Color" '("custom color" "auto select" "black" "white" "cream" "gray")
  SF-COLOR      "Custom Color"         '(139 78 76)
  SF-ADJUSTMENT "Frame Size" '(20 0 100 1 5 0 0)
  SF-TOGGLE     "Flatten"   FALSE
    
  )
(script-fu-menu-register "script-fu-gmic-logos" "<Image>/File/Create/Logos")