;;mhgradient
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhgradient text size font 3d md text-gradient opa mm ns bg-color white? stp ck?)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 12) 4) TRUE size PIXELS font)))
;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
)
    (gimp-image-undo-disable img)

;;TCY
    (if (= md 0) (gimp-image-resize img (+ width (* 3d stp)) (+ height (* 3d stp)) (* 3d stp) (* 3d stp)))	;rb-slant
    (if (= md 1) (gimp-image-resize img width (+ height (* (* 3d stp) 2)) 0 (* (* 3d stp) 2)))		;b-vertical
    (if (= md 2) (gimp-image-resize img (+ width (* 3d stp)) (+ height (* 3d stp)) 0 (* 3d stp)))	;lb-slant
    (if (= md 3) (gimp-image-resize img (+ width (* (* 3d stp) 2)) height 0 0))				;l-horizontal
    (if (= md 4) (gimp-image-resize img (+ width (* 3d stp)) (+ height (* 3d stp)) 0 0))		;lt-slant
    (if (= md 5) (gimp-image-resize img width (+ height (* (* 3d stp) 2)) 0 0))				;t-vertical
    (if (= md 6) (gimp-image-resize img (+ width (* 3d stp)) (+ height (* 3d stp)) (* 3d stp) 0))	;rt-slant
    (if (= md 7) (gimp-image-resize img (+ width (* (* 3d stp) 2)) height (* (* 3d stp) 2) 0))		;r-horizontal

    (if (= md 0) (gimp-layer-resize text-layer (+ width (* 3d stp)) (+ height (* 3d stp)) (* 3d stp) (* 3d stp)))	;rb-slant
    (if (= md 1) (gimp-layer-resize text-layer width (+ height (* (* 3d stp) 2)) 0 (* (* 3d stp) 2)))		;b-vertical
    (if (= md 2) (gimp-layer-resize text-layer (+ width (* 3d stp)) (+ height (* 3d stp)) 0 (* 3d stp)))	;lb-slant
    (if (= md 3) (gimp-layer-resize text-layer (+ width (* (* 3d stp) 2)) height 0 0))				;l-horizontal
    (if (= md 4) (gimp-layer-resize text-layer (+ width (* 3d stp)) (+ height (* 3d stp)) 0 0))			;lt-slant
    (if (= md 5) (gimp-layer-resize text-layer width (+ height (* (* 3d stp) 2)) 0 0))				;t-vertical
    (if (= md 6) (gimp-layer-resize text-layer (+ width (* 3d stp)) (+ height (* 3d stp)) (* 3d stp) 0))	;rt-slant
    (if (= md 7) (gimp-layer-resize text-layer (+ width (* (* 3d stp) 2)) height (* (* 3d stp) 2) 0))		;r-horizontal

    (script-fu-mhgradientimg img text-layer 3d md text-gradient opa mm ns bg-color white? stp ck?)

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mhgradient"
		    "<Image>/File/Create/Logos/Gradient..."
		    "mhgradient"
		    "Kiki"
		    "Kiki"
		    "2012/1"
		    ""
		    SF-STRING     "Text String"        "Gradient"
		    SF-ADJUSTMENT "Font Size (pixels)" '(100 2 1000 1 10 0 1)
		    SF-FONT       "Font"               "SneakOut"
		    SF-ADJUSTMENT "3D"			'(10 1 600 1 2 0 1)
                    SF-OPTION     "direction"             '(_"right-bottom" _"vertical-bottom" _"left-bottom" _"left-horizontal" _"left-top" _"vertical-top" _"right-top" _"right-horizontal")
                    SF-GRADIENT   "Gradient"           "Shadows 1"
		    SF-ADJUSTMENT "Opacity"            '(5 1 100 1 2 0 0)
                    SF-OPTION     "mode"               '(_"normal" _"noise" _"tile" _"fractal")
		    SF-ADJUSTMENT "noise"              '(0.2 0.01 1 0.01 0.02 2 0)
		    SF-COLOR      "Background Color"   '(243 255 222)
                    SF-TOGGLE     "white?"              FALSE
		    SF-ADJUSTMENT  "step"  		'(1 1 5 1 2 0 1)
                    SF-TOGGLE     "sp?"  		FALSE
)


(define (script-fu-mhgradientimg img drawable 3d md text-gradient opa mm ns bg-color white? stp ck?)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
;;wi
	 (bg-layer (car (gimp-layer-new img (+ width 10) (+ height 10) RGB-IMAGE "Background" 100 NORMAL-MODE)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))

;;2.4ǉ
	 (l1) (l2) (l20)
	 (l21)
	 (k1) (a 0) (b 0) (c 0) (d 0) (olda 0) (y 0)
)
    (gimp-image-undo-group-start img)

;;OiF̌
    (gimp-palette-set-foreground '(0 0 0))
    (gimp-layer-set-preserve-trans drawable TRUE)
    (gimp-edit-fill drawable FOREGROUND-FILL)
    (gimp-layer-set-opacity drawable opa)

    (cond((= 0 md)
	(set! a -1)
	(set! b 0)
	(set! c 0)
	(set! d -1)
	)
       ((= 1 md)
	(set! a 0)
	(set! b -1)
	(set! c 0)
	(set! d -1)
	)
       ((= 2 md)
	(set! a 1)
	(set! b 0)
	(set! c 0)
	(set! d -1)
	)
       ((= 3 md)
	(set! a 1)
	(set! b 0)
	(set! c 1)
	(set! d 0)
	)
       ((= 4 md)
	(set! a 1)
	(set! b 0)
	(set! c 0)
	(set! d 1)
	)
       ((= 5 md)
	(set! a 0)
	(set! b 1)
	(set! c 0)
	(set! d 1)
	)
       ((= 6 md)
	(set! a -1)
	(set! b 0)
	(set! c 0)
	(set! d 1)
	)
       ((= 7 md)
	(set! a -1)
	(set! b 0)
	(set! c -1)
	(set! d 0)
	)
     )

	(set! a (* a stp))
	(set! b (* b stp))
	(set! c (* c stp))
	(set! d (* d stp))
	(set! olda a)


    (set! y 0)
    (set! l2 (car (gimp-layer-copy drawable 0)))
    (while (< y 3d)
	(set! l1 (car (gimp-layer-copy l2 0)))
	(gimp-image-add-layer img l1 0)
	(gimp-layer-translate l1 a b)
	(set! l2 (car (gimp-layer-copy l1 0)))
	(gimp-image-add-layer img l2 0)
	(gimp-layer-translate l2 c d)
	(set! y (+ y 1))


	(if (= ck? TRUE)
		(if (> y (/ 3d 2))
			(begin
			(if (= a olda) (set! a (- 0 a)))
			(cond((= 1 md)
			   (if (= 0 a)
			   (begin
				 (set! a 1)
				 (gimp-image-resize img (+ width (/ 3d 2)) height 0 0)
			    ))
			)
			((= 3 md)
			   (if (= 0 d)
			   (begin
				 (set! d 1)
				 (if (> stp 1) (set! width (+ 10 width)))
				 (gimp-image-resize img (- width (* 3d stp)) (+ height (/ 3d 2)) 0 0)
			    ))
			)
			((= 5 md)
			   (if (= 0 a)
			   (begin
				 (set! a 1)
				 (gimp-image-resize img (+ width (/ 3d 2)) height 0 0)
			    ))
			)
			((= 7 md)
			   (if (= 0 d)
			   (begin
				 (set! d 1)
				 (if (> stp 1) (set! width (+ 10 width)))
				 (if (= stp 1) (gimp-image-resize img (- width (* 3d stp)) (+ height (/ 3d 2)) (- 0 (* 3d stp)) 0))
				 (if (> stp 1) (gimp-image-resize img (- width (* 3d stp)) (+ height (/ 3d 2)) (+ (- 0 (* 3d stp)) 10) 0))
			    ))
			)
	)


			)
		)
	)

    )
    (set! l20 (car (gimp-layer-copy l2 0)))
    (set! k1 (car (gimp-image-merge-visible-layers img 0)))

    (gimp-gradients-set-gradient text-gradient)
    (gimp-layer-set-preserve-trans k1 TRUE)
    (gimp-edit-blend k1 CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 width 0)

    (if (= mm 1) (plug-in-noisify 1 img k1 0 ns ns ns 0))
    (if (= mm 2) (plug-in-mosaic 1 img k1 15 4 1 0.65 1 135 0.2 1 1 1 0 0))
    (if (= mm 3) (plug-in-fractalexplorer 1 img k1 6 -0.07837 0.15820 -0.48578 -0.19739 134.96899 0.11 0.037 1 1 1 1 1 2 0 0 0 0 256))

    (gimp-image-add-layer img l20 0)
    (gimp-layer-translate l20 0 -1)
    (gimp-layer-set-opacity l20 100)
    (gimp-edit-blend l20 CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 width 0)
    (set! l21 (car (gimp-layer-copy l20 0)))
    (gimp-image-add-layer img l21 0)
    (gimp-layer-translate l21 -1 -1)
    (gimp-edit-blend l21 CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE width 0 0 0)
    (if (= TRUE white?)
    (begin
      (gimp-palette-set-foreground '(255 255 255))
      (gimp-edit-fill l21 FOREGROUND-FILL)
      (gimp-layer-set-opacity l21 50)
    ))
    (gimp-image-merge-visible-layers img 0)

;;wiF̌(bg-layeř̐̓C[̏Ԃł)
    (gimp-palette-set-foreground bg-color)
    (gimp-image-add-layer img bg-layer 1)
    (gimp-layer-resize-to-image-size bg-layer)		;add
    (gimp-drawable-fill bg-layer FOREGROUND-FILL)

;    (if (= TRUE fr?) (gimp-image-flatten img))

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)

    (gimp-image-undo-group-end img)
    (gimp-displays-flush)
))



;Tosilscript-fugp܂B
;http://www.geocities.jp/gimproject/scripts/layers-view-delete.html

(define (script-fu-layers-view-none image drawable)
 (let* ((layers (gimp-image-get-layers image))
	    (number-layers (car layers))
	    (layer-array (cadr layers))
	    (layer-count 0)
	    (layer))
    (set! layer-count 0)
    (while (< layer-count number-layers)
           (set! layer (aref layer-array layer-count))
           (gimp-drawable-set-visible layer FALSE)
           (set! layer-count (+ layer-count 1)))
))
(define (script-fu-layers-view-current-only image drawable)
    (script-fu-layers-view-none image drawable)
    (if (not (= 0 (car (gimp-drawable-is-layer drawable))))
        (gimp-drawable-set-visible drawable TRUE))
)



;{
(define (script-fu-mhgradientimgh img2 drawable2 resize? 3d md text-gradient opa mm ns bg-color white? stp ck?)
  (let* (
	(img (car (gimp-channel-ops-duplicate img2)))
	(drawable (car (gimp-image-get-active-layer img)))

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
;;wi
	 (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 NORMAL-MODE)))
	 (bump-layer (car (gimp-layer-new img width height RGB-IMAGE "Bump" 100 NORMAL-MODE)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))
)
    (gimp-image-undo-disable img)

    (script-fu-layers-view-current-only img drawable)	;Tosilscript-fu

;;TCY
(if (= resize? TRUE)
(begin
    (if (= md 0) (gimp-image-resize img (+ width (* 3d stp)) (+ height (* 3d stp)) (* 3d stp) (* 3d stp)))	;rb-slant
    (if (= md 1) (gimp-image-resize img width (+ height (* (* 3d stp) 2)) 0 (* (* 3d stp) 2)))		;b-vertical
    (if (= md 2) (gimp-image-resize img (+ width (* 3d stp)) (+ height (* 3d stp)) 0 (* 3d stp)))	;lb-slant
    (if (= md 3) (gimp-image-resize img (+ width (* (* 3d stp) 2)) height 0 0))				;l-horizontal
    (if (= md 4) (gimp-image-resize img (+ width (* 3d stp)) (+ height (* 3d stp)) 0 0))		;lt-slant
    (if (= md 5) (gimp-image-resize img width (+ height (* (* 3d stp) 2)) 0 0))				;t-vertical
    (if (= md 6) (gimp-image-resize img (+ width (* 3d stp)) (+ height (* 3d stp)) (* 3d stp) 0))	;rt-slant
    (if (= md 7) (gimp-image-resize img (+ width (* (* 3d stp) 2)) height (* (* 3d stp) 2) 0))		;r-horizontal

    (if (= md 0) (gimp-layer-resize drawable (+ width (* 3d stp)) (+ height (* 3d stp)) (* 3d stp) (* 3d stp)))	;rb-slant
    (if (= md 1) (gimp-layer-resize drawable width (+ height (* (* 3d stp) 2)) 0 (* (* 3d stp) 2)))		;b-vertical
    (if (= md 2) (gimp-layer-resize drawable (+ width (* 3d stp)) (+ height (* 3d stp)) 0 (* 3d stp)))	;lb-slant
    (if (= md 3) (gimp-layer-resize drawable (+ width (* (* 3d stp) 2)) height 0 0))				;l-horizontal
    (if (= md 4) (gimp-layer-resize drawable (+ width (* 3d stp)) (+ height (* 3d stp)) 0 0))			;lt-slant
    (if (= md 5) (gimp-layer-resize drawable width (+ height (* (* 3d stp) 2)) 0 0))				;t-vertical
    (if (= md 6) (gimp-layer-resize drawable (+ width (* 3d stp)) (+ height (* 3d stp)) (* 3d stp) 0))	;rt-slant
    (if (= md 7) (gimp-layer-resize drawable (+ width (* (* 3d stp) 2)) height (* (* 3d stp) 2) 0))
))

    (script-fu-mhgradientimg img drawable 3d md text-gradient opa mm ns bg-color white? stp ck?)

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mhgradientimgh"
		    "<Image>/Script-Fu/MH/Gradient"
		    "mhgradientimg"
		    "Kiki"
		    "Kiki"
		    "2005/1"
		    "RGBA"
		    SF-IMAGE      "Image"     0
		    SF-DRAWABLE   "Drawable"  0
                    SF-TOGGLE     "resize?"  		TRUE
		    SF-ADJUSTMENT "3D"			'(10 1 600 1 2 0 1)
                    SF-OPTION     "direction"             '(_"right-bottom" _"vertical-bottom" _"left-bottom" _"left-horizontal" _"left-top" _"vertical-top" _"right-top" _"right-horizontal")
                    SF-GRADIENT   "Gradient"           "Shadows 1"
		    SF-ADJUSTMENT "Opacity"            '(5 1 100 1 2 0 0)
                    SF-OPTION     "mode"               '(_"normal" _"noise" _"tile" _"fractal")
		    SF-ADJUSTMENT "noise"              '(0.2 0.01 1 0.01 0.02 2 0)
		    SF-COLOR      "Background Color"   '(243 255 222)
                    SF-TOGGLE     "white?"              FALSE
		    SF-ADJUSTMENT  "step"  		'(1 1 5 1 2 0 1)
                    SF-TOGGLE     "sp?"  		FALSE
)

