;Icicle-logo.scm
;
; Create a new logo:   File > Create > Logos > Icicle...
; Alpha to Logo:  Filters > Alpha to Loga > Icicle...
;
;;
;; origine : http://www.upstateforums.com/userfiles/gimp2.4scripts/icefire-logo.scm.zip
;;
;; Icicle logo
;;
;; --------------------------------------------------------------------
;; version 1.0 by Michael Schalla 2003/02/17
;; version 2.0 by Eric Lamarque 2004/08/20
;; version 3.0 ( modifications : register, autocrop, Absolute Size ) by samj (www.aljacom.com/~gimp) 2010/12/02
;; --------------------------------------------------------------------
;; Updated to Gimp2.4 (12/07)
;; http://www.gimpscripts.com
;;
;
; Modify icefire-logo.scm to create icicles instead and fix Alpha to Logo script   Brian Hahn   12-Jan-12
;
;

(define (apply-icicle-logo-effect img inLayer inGrow inIce inIce2 inColor autocrop)
	(let*
		(
			(width (car (gimp-drawable-width inLayer)))
			(height (car (gimp-drawable-height inLayer)))

			(theIcicleLayer (car (gimp-layer-new img width height RGBA-IMAGE "Icicle" 100 NORMAL)))

			(old-fg (car (gimp-palette-get-foreground)))
			(old-bg (car (gimp-palette-get-background)))
		)

	(gimp-image-resize img width height 0 0)
	(gimp-image-add-layer img theIcicleLayer 0)
	(gimp-edit-clear theIcicleLayer)

	(gimp-selection-layer-alpha inLayer)

	(if (> inGrow 0)
		(gimp-selection-grow img inGrow)
		(if (< inGrow 0)
			(gimp-selection-shrink img (- 0 inGrow))
		)
	)

	(gimp-palette-set-foreground '(255 255 255))
	(gimp-edit-fill theIcicleLayer FG-IMAGE-FILL)
	(gimp-selection-none img)

	(plug-in-cubism 1 img theIcicleLayer inIce2 2.5 0)
;	(plug-in-rotate 1 img theIcicleLayer 3 FALSE)
	(plug-in-rotate 1 img theIcicleLayer 1 FALSE)			;ice going down instead of fire going up
	(plug-in-wind 1 img theIcicleLayer 10 1 inIce 1 1)
;	(plug-in-rotate 1 img theIcicleLayer 1 FALSE)
	(plug-in-rotate 1 img theIcicleLayer 3 FALSE)
	(plug-in-ripple 1 img theIcicleLayer (* 2 inIce2) (/ inIce2 3) 1 0 1 TRUE FALSE)
	(plug-in-spread 1 img theIcicleLayer inIce2 inIce2)

	(plug-in-gauss-iir 1 img theIcicleLayer 3 TRUE TRUE)

	(define (set-pt a index x y)
		(begin
			(aset a (* index 2) x)
			(aset a (+ (* index 2) 1) y)
		)
	)

	(define (splineValue)
	(let* 
		(
			(a (cons-array 33 'byte))
		)
			
		(set-pt a 0 0 0)
		(set-pt a 1 32 255)
		(set-pt a 2 64 128)
		(set-pt a 3 96 72)
		(set-pt a 4 128 184)
		(set-pt a 5 160 128)
		(set-pt a 6 192 255)
		(set-pt a 7 224 128)
		(set-pt a 8 240 255)
		(set-pt a 9 252 128)
		(set-pt a 10 255 255)
		a
		)
	)
		
	(gimp-curves-spline theIcicleLayer VALUE-LUT 22 (splineValue))

	;(define red (larg-default inColor 0 0))
	(define red (nth 0 inColor))
		
	(if (= red 0)
		(set! red 1)
		(if (= red 255)
			(set! red 254)
		)
	)

	;(define green (larg-default inColor 1 0))
	(define green (nth 1 inColor))
		
	(if (= green 0)
		(set! green 1)
		(if (= green 255)
			(set! green 254)
		)
	)

	;(define blue (larg-default inColor 2 0))
	(define blue (nth 2 inColor))
		
	(if (= blue 0)
		(set! blue 1)
		(if (= blue 255)
			(set! blue 254)
		)
	)
	(define gray (/ (+ (* red 299) (* green 587) (* blue 114)) 1000))

	(define (splineRed)		
		(let* 
			(
				(a (cons-array 6 'byte))
			)
				
		(set-pt a 0 0 0)
		(set-pt a 1 gray red)
		(set-pt a 2 255 255)
		a
		)
	)
		
	(gimp-curves-spline theIcicleLayer RED-LUT 6 (splineRed))

	(define (splineGreen)
		(let* 
			(
				(a (cons-array 6 'byte))
			)
				
		(set-pt a 0 0 0)
		(set-pt a 1 gray green)
		(set-pt a 2 255 255)
		a
		)
	)
		
	(gimp-curves-spline theIcicleLayer GREEN-LUT 6 (splineGreen))

	(define (splineBlue)
		(let* 
			(
				(a (cons-array 6 'byte))
			)
				
		(set-pt a 0 0 0)
		(set-pt a 1 gray blue)
		(set-pt a 2 255 255)
		a
		)
	)
		
	(gimp-curves-spline theIcicleLayer BLUE-LUT 6 (splineBlue))

	(gimp-curves-spline theIcicleLayer ALPHA-LUT 22 (splineValue))

		; ajout samj
		(if 
			(= autocrop TRUE) 
				(plug-in-autocrop 1 img theIcicleLayer)
		)	
	
	(gimp-palette-set-background old-bg)
	(gimp-palette-set-foreground old-fg)
	
	)
)

(define (script-fu-icicle-alpha img theLayer inGrow inIce inIce2 inIceColor)
	(begin
		(gimp-undo-push-group-start img)

		(gimp-layer-resize-to-image-size theLayer)
		(apply-icicle-logo-effect img theLayer inGrow inIce inIce2 inIceColor 0)

		(gimp-undo-push-group-end img)
		(gimp-displays-flush)
	)
)

(script-fu-register "script-fu-icicle-alpha"
	"<Image>/Filters/Alpha to Logo/Icicle..."
	"Creates a icicle logo.\n[Icicle-logo.scm]"
	"Michael Schalla"
	"Michael Schalla"
	"Februar 2001"
	"RGBA"
	SF-IMAGE		"Image"			0
	SF-DRAWABLE		"Drawable"		0
	SF-ADJUSTMENT	"Grow"			'(-6 -50 50 1 1 0 1)
	SF-ADJUSTMENT	"Ice-Dim1"		'(32 2 100 1 1 0 1)
	SF-ADJUSTMENT	"Ice-Dim2"		'(8 2 100 1 1 0 1)
	SF-COLOR		"Ice Color"		'(32 64 128)
)

(define (script-fu-icicle-logo inText inFont inFontSize inIceColor inTextColor inGrow inIce inIce2 inAbsolute inImageWidth inImageHeight inFlatten autocrop)
	(let*
		(
			; Definition unserer lokalen Variablen

			; Erzeugen des neuen Bildes

			(img ( car (gimp-image-new 10 10 RGB)))
			(theText)
			(theTextWidth)
			(theTextHeight)
			(imgWidth)
			(imgHeight)
			(theBufferX)
			(theBufferY)
			(theTextLayer2)

			; Erzeugen einer neuen Ebene zum Bild
			(theLayer (car (gimp-layer-new img 10 10 RGB-IMAGE "Ebene 1" 100 NORMAL)))
			(theTextLayer (car (gimp-layer-new img 10 10 RGBA-IMAGE "Ebene 2" 100 NORMAL)))

			(old-fg (car (gimp-palette-get-foreground)))
			(old-bg (car (gimp-palette-get-background)))
			; Ende unserer lokalen Variablen
		)

	(gimp-image-add-layer img theLayer 0)
	(gimp-image-add-layer img theTextLayer 0)

	(gimp-palette-set-background '(0 0 0) )
	(gimp-palette-set-foreground inTextColor)

	(gimp-selection-all img)
	(gimp-edit-clear theLayer)
	(gimp-edit-clear theTextLayer)
	(gimp-selection-none img)

	(set! theText (car (gimp-text-fontname img theTextLayer 0 0 inText 0 TRUE inFontSize PIXELS inFont)))

	(set! theTextWidth (car (gimp-drawable-width theText)))
	(set! theTextHeight (car (gimp-drawable-height theText)))

	(set! imgWidth inImageWidth )
	(set! imgHeight inImageHeight )

	; modif samj
	;(if (= inAbsolute FALSE)
		(set! imgWidth (+ theTextWidth theTextHeight inIce inIce2 ))
	;)

	; modif samj
	;(if (= inAbsolute FALSE)
		(set! imgHeight (+ (* theTextHeight 1.5 ) (* 4 (+ inIce inIce2 inGrow ))))
	;)

	(set! theBufferX (/ (- imgWidth theTextWidth) 2) )
;	(set! theBufferY (+ (/ (- imgHeight theTextHeight) 2) (+ inIce inIce inIce2 inGrow )))
	(set! theBufferY (/ theTextHeight 4) )		;text near the top, icicles down

	(gimp-image-resize img imgWidth imgHeight 0 0)
	(gimp-layer-resize theLayer imgWidth imgHeight 0 0)
	(gimp-layer-resize theTextLayer imgWidth imgHeight 0 0)

	(gimp-layer-set-offsets theText theBufferX theBufferY )
	(gimp-floating-sel-anchor theText)

	(set! theTextLayer2 (car (gimp-layer-copy theTextLayer TRUE)))
	(gimp-image-add-layer img theTextLayer2 1)

	(plug-in-gauss-iir 1 img theTextLayer2 16 TRUE TRUE)
	(plug-in-bump-map 1 img theTextLayer theTextLayer2 135.0 45.0 32 0 0 0 0 TRUE FALSE 0)

	(gimp-selection-layer-alpha theTextLayer)
	(gimp-selection-grow img 2)
	(gimp-selection-feather img 8)

	(gimp-palette-set-foreground '(255 255 255))
	(gimp-edit-fill theTextLayer2 FG-IMAGE-FILL)
	(gimp-selection-none img)

	(apply-icicle-logo-effect img theTextLayer inGrow inIce inIce2 inIceColor autocrop)

	(if (= inFlatten TRUE)
		(gimp-image-flatten img)
	()
	)


	; modif samj
	(if 
		(= inAbsolute TRUE)
			(begin
				; aplatir et redimensionner image
				(gimp-image-flatten img)
				(gimp-image-resize img inImageWidth inImageHeight 0 0)
				(gimp-layer-scale-full (car (gimp-image-get-active-layer img)) inImageWidth inImageHeight FALSE 2)
				(gimp-layer-resize (car (gimp-image-get-active-layer img)) inImageWidth inImageHeight 0 0)					
			)
	)	
	
	
	
	(gimp-palette-set-background old-bg)
	(gimp-palette-set-foreground old-fg)

	(gimp-display-new img)
	(list img theLayer theText)

	)
)

(script-fu-register
	"script-fu-icicle-logo"
	"<Image>/File/Create/Logos/Icicle..."
	"Creates a icicle logo.\n\n[Icicle-logo.scm]"
	"Michael Schalla"
	"Michael Schalla"
	"October 2002"
	""
	SF-STRING		"Text"					"Icicle Logo"
	SF-FONT			"Font"					"Arial"	
	SF-ADJUSTMENT	"Font Size"				'(200 2 1000 1 10 0 1)
	SF-COLOR		"Ice Color"				'(32 64 128)
	SF-COLOR		"Text Color"			'(64 128 128)
	SF-ADJUSTMENT	"Grow"					'(-6 -50 50 1 1 0 1)
	SF-ADJUSTMENT	"Ice-Dim1"				'(32 2 100 1 1 0 1)
	SF-ADJUSTMENT	"Ice-Dim2"				'(8 2 100 1 1 0 1)
	SF-TOGGLE		"Absolute Size and Flatten?" FALSE
	SF-ADJUSTMENT	"Image Width"			'(400 10 10000 10 50 0 1)
	SF-ADJUSTMENT	"Image Height"			'(200 10 10000 10 50 0 1)
	SF-TOGGLE		"Flatten Layers?"		FALSE
	SF-TOGGLE		"Autocrop logo"			FALSE
)
