; Image Shine rel 0.04
; Created by Graechan
;
; You will need to install Hejianns beatify plugin to use all the backgrounds
; Avialable from Samj (Gimp 2.8 win & linux) http://www.aljacom.com/~gimp/hejiann-beautify-v0.5.3-7-win-32bits-64bits.zip
; or Rod at Gimp Chat (gimp 2.6 win32bit) http://www.gimpchat.com/viewtopic.php?f=9&t=4913&sid=8d76b9fe609edb296c0daa6eda99a116
;                     (gimp 2.8 win32bit) http://www.gimpchat.com/viewtopic.php?f=9&t=4811&sid=8d76b9fe609edb296c0daa6eda99a116
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
; Rel 0.02 - Added simple Borders from Beautify
; Rel 0.03 - Added More background choices including 1 that does not use the Beautify plugin "Samj's mystery pick"
; Rel 0.04 - Added More background choices Totalling 16 now 
(define (script-fu-shine-logo 
				      img-width
				      img-height
				      text
				      font-in 
				      font-size
                                      fill-type
				      fill-pattern
				      fill-color
				      fill-gradient
				      bkg-type
				      border-type
				      cont
				      shadow-size
				      shadow-blur
				      shadow-opacity
				      keep-selection-in
				      conserve)
  (let* (
         (width img-width)
         (height img-height)
         (offx 0)
         (offy 0)
         (image (car (gimp-image-new img-width img-height RGB)))         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (text-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (text-width (car (gimp-drawable-width text-layer)))
         (text-height (car (gimp-drawable-height text-layer)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-bg (car (gimp-palette-get-background)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))
         )
		 
;;;;;    (gimp-context-push)
	(gimp-palette-set-foreground '(0 0 0))
	(gimp-palette-set-background '(255 255 255))
	
;;;;centre text on line
;;;	(gimp-text-layer-set-justification text-layer 2)
	(if (symbol-bound? 'gimp-text-layer-set-justification (the-environment))		;change 2.4
	    (gimp-text-layer-set-justification text-layer 2)					;change 2.4
	    (gimp-message "\"gimp-text-layer-set-justification\" is not found! Can't use...")
	)	;change 2.4

;;;;set the new Image size
	(if (> text-width img-width) (set! width text-width))           
    (if (> text-height img-height) (set! height text-height))

;;;;square up the Image if needed	
    ;(if (< height width) (set! height width))
	;(if (< width height) (set! width height))

;;;;resize the image	
	(gimp-image-resize image width height 0 0)

	;;;;centre the text layer	
    (set! offx (/ (- width text-width) 2))
    (set! offy (/ (- height text-height) 2))    
    (gimp-layer-set-offsets text-layer offx offy)

;;;;set the text clolor    
    (gimp-palette-set-foreground '(0 0 0))
	(gimp-selection-layer-alpha text-layer)	
	(gimp-edit-fill text-layer FOREGROUND-FILL)
	(gimp-selection-none image)

;;;;resize the text-layer		
    (gimp-image-set-active-layer image text-layer)
	(gimp-layer-resize-to-image-size text-layer)	
    
	(script-fu-shine-alpha-to-logo image text-layer
							   font-size
							   fill-type
							   fill-pattern
							   fill-color
							   fill-gradient
							   bkg-type
							   border-type
							   cont
							   shadow-size
							   shadow-blur
							   shadow-opacity
							   keep-selection-in
							   conserve)
							   
;;;;;	(gimp-context-pop)
	(gimp-palette-set-foreground old-fg)
	(gimp-palette-set-background old-bg)
	(gimp-gradients-set-active old-grad)
	(gimp-patterns-set-pattern old-pat)
	(gimp-display-new image)
	
    )
  ) 
(script-fu-register "script-fu-shine-logo"
  "<Image>/File/Create/Logos/Shine Logo..."
  "Leave Background Type set to None or mystery unless you have the Beautify plugin installed"
  "Graechan"
  "Graechan"
  "Aug 2011"
  ""
  SF-ADJUSTMENT "Image width (pixels)" '(250 1 1000 1 10 0 1)
  SF-ADJUSTMENT "Image height(pixels)" '(250 1 1000 1 10 0 1)
  SF-TEXT       "Text"    "Shine"
  SF-FONT       "Font"               "JasmineUPC Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(300 36 1000 1 1 0 1)
  SF-OPTION "Text Fill Type" '("Pattern" "Color" "Gradient")
  SF-PATTERN    "Text Pattern"            "Wood #2"
  SF-COLOR      "Text color"         '(153 153 153)
  SF-GRADIENT   "Text Gradient" "Abstract 3"
  SF-OPTION "Background Type" '("None" "Samj's mystery pick" "Bright Red" "Night View" "Colorfull Glow" "Pick Light" "Classic Sketch" "Color Pencil" "Sunset Gradient" "Pink-Purple Gradient" "Beam Gradient" "Rainbow Gradient" "Pink-Blue Gradient" "Classic Lomo" "Recall" "Cloudy Paper" "Water Bubbles")
  SF-TOGGLE     "Apply a Simple Border (needs Beautify plugin)"   FALSE
  SF-ADJUSTMENT "Contrast" '(60 0 100 1 5 0 0)
  SF-ADJUSTMENT "Shadow Size" '(8 0 30 1 10 0 0)
  SF-ADJUSTMENT "Shadow Blur" '(8 0 50 1 10 0 0)
  SF-ADJUSTMENT "Shadow Opacity" '(50 0 100 1 10 0 0)
  SF-TOGGLE     "Keep selection"          FALSE
  SF-TOGGLE     "Keep the Layers"   FALSE
  )


(define (script-fu-shine-alpha-to-logo image drawable
							   font-size
							   fill-type
							   fill-pattern
							   fill-color
							   fill-gradient
							   bkg-type
							   border-type
							   cont
							   shadow-size
							   shadow-blur
							   shadow-opacity
							   keep-selection-in
							   conserve)
    
	(gimp-image-undo-group-start image)
 
 (let* (
            (image-layer (car (gimp-image-get-active-layer image)))
			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
			(alpha (car (gimp-drawable-has-alpha image-layer)))
			(sel (car (gimp-selection-is-empty image)))
			(layer-name (car (gimp-drawable-get-name image-layer)))
			(selection-channel 0)
			(fill-layer 0)
			(bkg-layer 0)
			(random_gradient 0)
			(gradient-type 0)
			(keep-selection keep-selection-in)
			(effect 0)
         (old-fg (car (gimp-palette-get-foreground)))
         (old-bg (car (gimp-palette-get-background)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))
        )	
	
;;;;;	(gimp-context-push)
    (gimp-palette-set-foreground '(0 0 0))
	(gimp-palette-set-background '(255 255 255))
	
	(if (= alpha FALSE) (gimp-layer-add-alpha image-layer))
	
;;;;check that a selection was made if not make one	
	(if (= sel TRUE) (set! keep-selection FALSE))
	(if (= sel TRUE) (gimp-selection-layer-alpha image-layer))

;;;;save the selection    
	(gimp-selection-save image)
	(set! selection-channel (car (gimp-image-get-active-drawable image)));set variable (beam-channel 0)	
	(gimp-channel-set-opacity selection-channel 100)	
	(gimp-drawable-set-name selection-channel "selection-channel")
	
;;;;create the fill layer	
	(set! fill-layer (car (gimp-layer-new image width height RGBA-IMAGE "Fill" 100 SCREEN-MODE)))
    (gimp-image-add-layer image fill-layer -1)
    (gimp-edit-clear fill-layer)			;add 2.4
    (gimp-selection-invert image)			;add 2.4
    (gimp-edit-clear fill-layer)			;add 2.4
    (gimp-selection-invert image)			;add 2.4
	(gimp-patterns-set-pattern fill-pattern)
	(gimp-palette-set-background fill-color)
	(gimp-gradients-set-gradient fill-gradient)
	(if (= fill-type 0) (gimp-edit-fill fill-layer PATTERN-FILL))		
    (if (= fill-type 1) (gimp-edit-fill fill-layer BACKGROUND-FILL))	
    (if (= fill-type 2) (gimp-edit-blend fill-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width height));; GRADIENT-LINEAR ; GRADIENT-CONICAL-SYMMETRIC
	(gimp-desaturate image-layer)
	(plug-in-edge 1 image image-layer 2.0 2 0)
	(gimp-brightness-contrast image-layer 0 cont)

;;;;create the background layer	
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 2)
    (gimp-edit-clear bkg-layer)				;add 2.4
    (gimp-selection-invert image)			;add 2.4
    (gimp-edit-clear bkg-layer)				;add 2.4
    (gimp-selection-invert image)			;add 2.4

;;;;tidy layers,channel and selection	
	(gimp-image-set-active-layer image fill-layer)	
	(if (= conserve FALSE) (set! image-layer (car (gimp-image-merge-down image fill-layer EXPAND-AS-NECESSARY))))
	(gimp-drawable-set-name image-layer layer-name)
	(if (= conserve TRUE) (gimp-drawable-set-name fill-layer "Texture"))

;;;;apply the shine effect to text	
	(the-shine image drawable shadow-size shadow-opacity keep-selection conserve font-size shadow-blur)
	(set! image-layer (car (gimp-image-get-active-layer image)))

;;;;create the random gradients
	(if (= bkg-type 1)
    (begin
	(gimp-selection-none image)
;;;	(gimp-palette-set-foreground '((round (random 255)) (round (random 255)) (round (random 255))))	;none 2.6
	(gimp-palette-set-foreground '(0 158 195))
	(gimp-palette-set-background '(53 175 213))
	(gimp-edit-blend bkg-layer FG-BG-RGB-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width height)
	(set! random_gradient (list-ref (cadr (gimp-gradients-get-list "")) (random (car (gimp-gradients-get-list "")))))
;;;	(set! gradient-type (round (random 10)))		;none 2.6
	(set! gradient-type LINEAR)				;change 2.6
	(gimp-gradients-set-gradient random_gradient)
	(gimp-edit-blend bkg-layer CUSTOM-MODE NORMAL-MODE gradient-type 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE (/ width 2) (/ height 2) width height)
	(gimp-selection-load selection-channel)
	(gimp-palette-set-foreground '(0 0 0))
	(gimp-palette-set-background '(255 255 255))))
	
;;;;setup for backrounds 10,11 and 12
	(if (> bkg-type 9)
    (begin
	(gimp-selection-none image)
	(gimp-palette-set-default-colors)
	(gimp-gradients-set-gradient "Deep Sea")
	(if (and (> bkg-type 9) (< bkg-type 13))(gimp-drawable-fill bkg-layer FOREGROUND-FILL))
	(if (> bkg-type 12) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))
	(if (= bkg-type 16) (gimp-edit-blend bkg-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE (/ width 2) height (/ width 2) 0))
	(gimp-selection-load selection-channel)))
	
;;;;create the background effect with the beautify plugin    
	(if (> bkg-type 1)
	(begin
	(set! effect
			(cond 
				(( equal? bkg-type 2 ) 53 )
				(( equal? bkg-type 3 ) 56 )
				(( equal? bkg-type 4 ) 58 )
				(( equal? bkg-type 5 ) 60 )
			    (( equal? bkg-type 6 ) 68 )
				(( equal? bkg-type 7 ) 69 )
				(( equal? bkg-type 8 ) 75 )
				(( equal? bkg-type 9 ) 80 )
		        (( equal? bkg-type 10 ) 74 )
				(( equal? bkg-type 11 ) 78 )
				(( equal? bkg-type 12 ) 81 )
				(( equal? bkg-type 13 ) 13 )
				(( equal? bkg-type 14 ) 30 )
				(( equal? bkg-type 15 ) 68 )
				(( equal? bkg-type 16 ) 64 )))
				
	(gimp-selection-none image)
	(gimp-image-set-active-layer image bkg-layer)
;;;	(plug-in-beautify 1 image bkg-layer effect 100)				;none 2.4
	(if (symbol-bound? 'plug-in-beautify (the-environment))			;change 2.4
	(plug-in-beautify 1 image bkg-layer effect 100)				;change 2.4
	(gimp-message "\"plug-in-beautify\" is not found! Can't use..."))	;change 2.4
	(set! bkg-layer (car (gimp-image-get-active-layer image)))
;;;	(if (= bkg-type 13) (plug-in-beautify 1 image bkg-layer 12 100))	;none 2.4
	(if (symbol-bound? 'plug-in-beautify (the-environment))			;change 2.4
	(if (= bkg-type 13) (plug-in-beautify 1 image bkg-layer 12 100))	;change 2.4
	(gimp-message "\"plug-in-beautify\" is not found! Can't use..."))	;change 2.4

	(set! bkg-layer (car (gimp-image-get-active-layer image)))))

;;;;apply the border from Beautify plugin
	(if (= border-type TRUE) 
	(begin
	(gimp-image-set-active-layer image bkg-layer)
	(plug-in-simple-border 0 image bkg-layer)))
	
	(if (= conserve FALSE) (set! image-layer (car (gimp-image-merge-down image image-layer EXPAND-AS-NECESSARY))))
    (gimp-drawable-set-name image-layer layer-name)
    (if (= keep-selection FALSE) (gimp-selection-none image))
	(gimp-image-remove-channel image selection-channel)
;;	(if (and (= conserve FALSE) (= alpha FALSE) (gimp-image-merge-visible-layers image 0)))	;none 2.2
	
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
;;;;;	(gimp-context-pop)
	(gimp-palette-set-foreground old-fg)
	(gimp-palette-set-background old-bg)
	(gimp-gradients-set-active old-grad)
	(gimp-patterns-set-pattern old-pat)

 )
)

(script-fu-register "script-fu-shine-alpha-to-logo"
                    "<Image>/Filters/Alpha to logo/Shine Alpha..."
                     "Leave Background Type set to None or mystery unless you have the Beautify plugin installed"
                    "Graechan"
                    "Graechan"
                    "Aug 2012"
                    "RGB*"
  SF-IMAGE      "image"      0
  SF-DRAWABLE   "drawable"   0
  SF-ADJUSTMENT "size" '(300 50 1000 1 1 0 1)
  SF-OPTION "Text Fill Type" '("Pattern" "Color" "Gradient")
  SF-PATTERN    "Text Pattern"            "Wood #2"
  SF-COLOR      "Text color"         '(153 153 153)
  SF-GRADIENT   "Text Gradient" "Abstract 3"
  SF-OPTION "Background Type" '("None" "Samj's mystery pick" "Bright Red(Beautify)" "Night View(Beautify)" "Colorfull Glow(Beautify)" "Pick Light(Beautify)" "Classic Sketch(Beautify)" "Color Pencil(Beautify)" "Sunset Gradient(Beautify)" "Pink-Purple Gradient(Beautify)" "Beam Gradient(Beautify)" "Rainbow Gradient(Beautify)" "Pink-Blue Gradient(Beautify)" "Classic Lomo(Beautify)" "Recall(Beautify)" "Cloudy Paper(Beautify)" "Water Bubbles(Beautify)")
  SF-TOGGLE     "Apply a Simple Border(needs Beautify plugin)"   FALSE
  SF-ADJUSTMENT "Contrast" '(60 0 100 1 5 0 0)
  SF-ADJUSTMENT "Shadow Size" '(8 0 50 1 10 0 0)
  SF-ADJUSTMENT "Shadow Blur" '(8 0 50 1 10 0 0)
  SF-ADJUSTMENT "Shadow Opacity" '(50 0 100 1 10 0 0)
  SF-TOGGLE     "Keep selection"          FALSE
  SF-TOGGLE     "Keep the Layers"   FALSE
)


(define (the-shine image drawable
							  shadow-size
							  shadow-opacity
							  keep-selection-in
							  conserve
							  font-size
							  shadow-blur)


 (let* (
            (image-layer (car (gimp-image-get-active-layer image)))
			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
			(sel (car (gimp-selection-is-empty image)))
			(alpha (car (gimp-drawable-has-alpha image-layer)))
			(layer-name (car (gimp-drawable-get-name image-layer)))
			(keep-selection keep-selection-in)
			(img-layer 0)
			(img-channel 0)
			(bkg-layer 0)
			(shadow-layer 0)
			(tmp-layer 0)
			(gauss1 0)
			(gauss2 0)
			(emboss1 0)
        )


;;;;;	(gimp-context-push)
    (gimp-image-undo-group-start image)
	(gimp-palette-set-foreground '(0 0 0))
	(gimp-palette-set-background '(255 255 255))

	(if (= alpha FALSE) (gimp-layer-add-alpha image-layer))
    
	(if (= sel TRUE) (set! keep-selection FALSE))
	(if (= sel TRUE) (gimp-selection-layer-alpha image-layer))
	
	(set! img-layer (car (gimp-layer-new image width height RGBA-IMAGE "img-layer" 100 NORMAL-MODE)))
	(gimp-image-add-layer image img-layer -1)
	(gimp-edit-clear img-layer)				;add 2.4
	(gimp-selection-invert image)				;add 2.4
	(gimp-edit-clear img-layer)				;add 2.4
	(gimp-selection-invert image)				;add 2.4
	(gimp-drawable-fill img-layer  BACKGROUND-FILL)
	(gimp-edit-fill img-layer FOREGROUND-FILL)
	
;;;;create channel
	(gimp-selection-save image)
	(set! img-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity img-channel 100)	
	(gimp-drawable-set-name img-channel "img-channel")
	(gimp-image-set-active-layer image img-layer)	
	(gimp-drawable-set-name image-layer layer-name)
	
;;;;create the background layer    
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 1)
    (gimp-edit-clear bkg-layer)					;add 2.4

;;;;apply the image effects
    (gimp-palette-set-foreground '(0 0 0))
	(gimp-palette-set-background '(255 255 255))
	(set! gauss1 (* (/ 12 500) font-size))			;add
	(if (< gauss1 1) (set! gauss1 1))			;add
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image img-layer gauss1 gauss1)	;changed
	(set! emboss1 (* (/ 10 500) font-size))			;add
	(if (< emboss1 1) (set! emboss1 1))			;add
	(plug-in-emboss RUN-NONINTERACTIVE image img-layer 225 84 emboss1 TRUE)
	(gimp-selection-invert image)
	(gimp-edit-clear img-layer)
	(gimp-selection-invert image)
	(plug-in-colortoalpha RUN-NONINTERACTIVE image img-layer '(254 254 254));;fefefe
	(plug-in-gauss-rle2 RUN-NONINTERACTIVE image img-channel 15 15)
;;;	(plug-in-blur RUN-NONINTERACTIVE image img-layer)	;none
	(gimp-selection-shrink image (* (/ 1 300) font-size))	;add
	(set! gauss2 (* (/ 3 500) font-size))			;add
	(if (< gauss2 1) (set! gauss2 1))			;add
	(plug-in-gauss-iir2 1 image img-layer gauss2 gauss2)	;changed
	(gimp-image-set-active-layer image bkg-layer)
	(plug-in-displace RUN-NONINTERACTIVE image bkg-layer 8 8 TRUE TRUE img-channel img-channel 0)
	(gimp-image-remove-layer image bkg-layer)

;;;;create the shadow
   (if (> shadow-size 0)
   (begin
    (script-fu-drop-shadow image img-layer shadow-size shadow-size shadow-blur '(0 0 0) shadow-opacity FALSE)
    (set! tmp-layer (car (gimp-layer-new image width height RGBA-IMAGE "temp" 100 NORMAL-MODE)))
    (gimp-image-add-layer image tmp-layer -1)
    (gimp-edit-clear tmp-layer)					;add 2.4
    (gimp-selection-invert image)				;add 2.4
    (gimp-edit-clear tmp-layer)					;add 2.4
    (gimp-selection-invert image)				;add 2.4
	(gimp-image-raise-layer image tmp-layer)
    (gimp-image-merge-down image tmp-layer CLIP-TO-IMAGE)
	(set! shadow-layer (car (gimp-image-get-active-drawable image)))
	(gimp-image-lower-layer image shadow-layer)))

;;;;tidy the layers, channels and selection
    (if (= conserve FALSE)
    (begin
	(set! img-layer (car (gimp-image-merge-down image img-layer EXPAND-AS-NECESSARY)))
	(set! img-layer (car (gimp-image-merge-down image img-layer EXPAND-AS-NECESSARY)))
	(gimp-drawable-set-name img-layer layer-name)))
	
	(if (= keep-selection FALSE) (gimp-selection-none image))	
	(gimp-image-remove-channel image img-channel)
	(if (and (= conserve FALSE) (= alpha FALSE) (gimp-image-merge-visible-layers image 0)))
	
	(gimp-image-undo-group-end image)
;;;;;	(gimp-context-pop)
    (gimp-displays-flush)

 )
)
