;;mhlogo1
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-kesu img llayer)
    (gimp-selection-all img)
    (gimp-edit-clear llayer)
    (gimp-selection-none img)
)


(define (script-fu-mhlogo1 text size font text-color text-color2 grad? grad1 grad2 gl hl bgm bg-color bgg bgp ft)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
;;text
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 12) 4) TRUE size PIXELS font)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-bg (car (gimp-palette-get-background)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))

)
(gimp-image-undo-disable img)

(script-fu-mhlogo1img img text-layer size text-color text-color2 grad? grad1 grad2 gl hl bgm bg-color bgg bgp ft)

    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mhlogo1"
		    "<Image>/File/Create/Logos/Logo 1..."
		    "mhlogo1"
		    "Kiki"
		    "Kiki"
		    "2005/3"
		    ""
		    SF-STRING   "Text String"      "Logo1"
		    SF-ADJUSTMENT "Font Size (pixels)" '(100 2 1000 1 10 0 1)
		    SF-FONT     "Font"             "GauFontMilkChoco"
		    SF-COLOR    "Text Color1(main)"       '(255 128 12)
		    SF-COLOR    "Text Color2"       '(255 255 195)
                    SF-TOGGLE   "Use gradient?"		FALSE
                    SF-GRADIENT   "Gradient1(main)"		"German flag smooth"
                    SF-GRADIENT   "Gradient2"		"Incandescent"
		    SF-ADJUSTMENT _"glow"           '(2 1 50 1 10 0 1)
		    SF-ADJUSTMENT _"border"        '(4 1 50 1 10 0 1)
                    SF-OPTION   "bg mode"           '(_"color" _"grad" _"pattern")
		    SF-COLOR    "Background Color"  '(0 0 0)
                    SF-GRADIENT "Background Gradient"     "Browns"
                    SF-PATTERN  "Background Pattern"      "Parque #1"
                    SF-TOGGLE   "Flatten Image"      TRUE)


(define (script-fu-mhlogo1img img drawable size text-color text-color2 grad? grad1 grad2 gl hl bgm bg-color bgg bgp ft)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
;;wi
	 (bg-layer (car (gimp-layer-new img (+ width (* gl 2)) (+ height (* gl 2)) RGB-IMAGE "Background" 100 NORMAL-MODE)))

;;ǉC[
	 (lcopy (car (gimp-layer-new img (+ width (* gl 2)) (+ height (* gl 2)) RGBA-IMAGE "lcopy" 100 NORMAL-MODE)))
	 (lhilight (car (gimp-layer-new img (+ width (* gl 2)) (+ height (* gl 2)) RGBA-IMAGE "lhilight" 100 NORMAL-MODE)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-bg (car (gimp-palette-get-background)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))

;;2.4ǉ(hldefineɂ)
	 (thzn)

)
    (gimp-image-undo-group-start img)
;;TCY
    (gimp-image-resize img (+ width (* gl 2)) (+ height (* gl 2)) gl gl)
    (set! thzn (car (gimp-layer-copy drawable 0)))
;;    (set! hl (- 10 hl))

     (script-fu-kesu img drawable)

    (gimp-image-add-layer img lcopy 1)
    (script-fu-kesu img lcopy)

    (gimp-image-add-layer img thzn 0)		;add 2.8

    (gimp-selection-layer-alpha thzn)
    (gimp-selection-grow img gl)
    (gimp-selection-feather img (* (/ size 100) 12))
    (gimp-palette-set-foreground text-color)
    (gimp-edit-fill lcopy FOREGROUND-FILL)
    (if (= grad? TRUE) 
    (begin
	(gimp-gradients-set-gradient grad1)
	(gimp-edit-blend lcopy CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 0 height)
	(plug-in-colortoalpha 1 img lcopy text-color)
    ))
    (gimp-selection-none img)

    (gimp-palette-set-background text-color2)
    (gimp-selection-layer-alpha thzn)
    (gimp-selection-feather img (* (/ size 100) 3))
    (gimp-edit-blend drawable 0 NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 0 height)
    (if (= grad? TRUE) 
    (begin
	(gimp-gradients-set-gradient grad2)
	(gimp-edit-blend drawable CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 0 height)
    ))
    (gimp-selection-none img)

    (gimp-image-add-layer img lhilight 0)
    (script-fu-kesu img lhilight)
    (gimp-selection-layer-alpha thzn)

    (gimp-image-remove-layer img thzn)		;add 2.8

    (gimp-selection-shrink img hl)
    (gimp-selection-feather img (* (/ size 100) 3))
    (gimp-palette-set-foreground text-color2)
    (gimp-palette-set-background text-color)
    (gimp-edit-blend lhilight 0 NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 0 height)
    (if (= grad? TRUE) 
    (begin
	(gimp-gradients-set-gradient grad1)
	(gimp-edit-blend lhilight CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 0 height)
    ))
    (gimp-selection-none img)

    (gimp-palette-set-foreground bg-color)
    (gimp-image-add-layer img bg-layer 3)
    (gimp-drawable-fill bg-layer FOREGROUND-FILL)
    (cond((= bgm 1)
       (gimp-gradients-set-gradient bgg)
       (gimp-edit-blend bg-layer CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 0 height))
    ((= bgm 2)
       (gimp-selection-all img)
       (gimp-patterns-set-pattern bgp)
       (gimp-edit-bucket-fill bg-layer PATTERN-BUCKET-FILL NORMAL-MODE 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))

    (if (= ft TRUE)
    (gimp-image-flatten img)
    )

    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-group-end img)
    (gimp-displays-flush)
))

(script-fu-register "script-fu-mhlogo1img"
		    "<Image>/Script-Fu/MH/logo1"
		    "mhlogo1"
		    "Kiki"
		    "Kiki"
		    "2005/3"
		    "RGBA"
		    SF-IMAGE        "Image"    0
		    SF-DRAWABLE     "Drawable" 0
		    SF-ADJUSTMENT "Size (pixels)" '(100 2 1000 1 10 0 1)
		    SF-COLOR	"Color1(main)"             '(122 152 255)
		    SF-COLOR	" Color2"        '(255 255 255)
                    SF-TOGGLE   "Use gradient?"		FALSE
                    SF-GRADIENT   "Gradient1(main)"		"German flag smooth"
                    SF-GRADIENT   "Gradient2"		"Incandescent"
		    SF-ADJUSTMENT _"glow"            '(2 1 50 1 10 0 1)
		    SF-ADJUSTMENT _"border"         '(4 1 50 1 10 0 1)
                    SF-OPTION     "bg mode"          '(_"color" _"grad" _"pattern")
		    SF-COLOR      "Background Color" '(0 0 0)
                    SF-GRADIENT   "Background Gradient"     "Browns"
                    SF-PATTERN    "Background Pattern"      "Parque #1"
                    SF-TOGGLE   "Flatten Image"       TRUE)
