;;mhmarble
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhkesu img llayer)
    (gimp-selection-all img)
    (gimp-edit-clear llayer)                   ;I𕔕
    (gimp-selection-none img)                  ;I
)

(define (script-fu-22mhmarble text size font foption text-color text-gradient gradmd gradmd2 pat 
				 msize turb hue1 hue2 sat1 sat2 blur bg-color)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 12) 4) TRUE size PIXELS font)))

;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))
	)

(gimp-image-undo-disable img)
;;TCY
    (gimp-image-resize img width height 0 0)

;OiF̐ݒ
  (gimp-palette-set-foreground text-color)
  (gimp-layer-set-preserve-trans text-layer TRUE)
  (gimp-edit-fill text-layer FG-IMAGE-FILL)
  (cond((= foption 1)
    (gimp-gradients-set-active text-gradient)
    (gimp-layer-set-preserve-trans text-layer TRUE)  ;ی
    (if (= 0 gradmd) (gimp-blend text-layer CUSTOM NORMAL gradmd2 100 20 REPEAT-NONE FALSE 0 0 0 0 0 0 width height))
    (if (= 1 gradmd) (gimp-blend text-layer CUSTOM NORMAL gradmd2 100 20 REPEAT-NONE FALSE 0 0 0 0 0 0 width 0))
    (if (= 2 gradmd) (gimp-blend text-layer CUSTOM NORMAL gradmd2 100 20 REPEAT-NONE FALSE 0 0 0 0 0 0 0 height))
    )
    ((= foption 2)
       (gimp-selection-layer-alpha text-layer)
       (gimp-patterns-set-pattern pat)
       (gimp-bucket-fill text-layer PATTERN-BUCKET-FILL NORMAL 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))

(script-fu-22mhmarbleimg img text-layer msize turb hue1 hue2 sat1 sat2 blur bg-color)

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-active old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-22mhmarble"
		    "<Image>/File/Create/Logos/Marble..."
		    "22mhmarble"
		    "Kiki"
		    "Kiki"
		    "2005/11"
		    ""
		    SF-STRING		"Text String"		"Marble"
		    SF-ADJUSTMENT	"Font Size (pixels)"	'(150 5 1000 1 10 0 1)
		    SF-FONT		"Font"			"Impact"
                    SF-OPTION		"fg-mode"		'(_"color" _"gradient" _"pattern")
		    SF-COLOR		"Text Color"		'(255 128 32)
                    SF-GRADIENT		"Gradient"		"Skyline"
                    SF-OPTION		"gradient-mode"		'(_"naname" _"yoko" _"tate")
                    SF-OPTION		"gradient-mode2"	'(_"0(LINEAR)" _"1" _"2" _"3" _"4" _"5" _"6" _"7" _"8" _"9" _"10")
                    SF-PATTERN		"Pattern"		"Pine?"
		    SF-ADJUSTMENT	"Marble Size"		'(8 0.1 16 1 2 1 0)
                    SF-TOGGLE		"Turbulent"		FALSE
		    SF-ADJUSTMENT	"Hue1"			'(50 1 180 1 2 0 0)
		    SF-ADJUSTMENT	"Hue2"			'(-50 -180 -1 1 2 0 0)
		    SF-ADJUSTMENT	"Saturation1"		'(0 0 100 1 2 0 0)
		    SF-ADJUSTMENT	"Saturation2"		'(0 -100 0 1 2 0 0)
		    SF-ADJUSTMENT	"bump size"		'(5 0 50 1 2 0 0)
		    SF-COLOR		"Background Color"	'(155 182 122)
)


(define (script-fu-22mhmarbleimg img drawable msize turb hue1 hue2 sat1 sat2 blur bg-color)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))

;;ǉC[
	 (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 NORMAL)))
	 (p-layer (car (gimp-layer-new img width height RGB-IMAGE "white" 100 NORMAL)))
	 (bp-layer (car (gimp-layer-copy drawable 0)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))

)
    (gimp-undo-push-group-start img)

    (gimp-image-add-layer img p-layer 0)
    (plug-in-solid-noise 1 img p-layer FALSE turb 1 1 msize msize)
    (gimp-by-color-select p-layer '(88 88 88) 25 REPLACE TRUE TRUE 3 FALSE)
    (gimp-hue-saturation drawable 0 hue1 sat1 0)
    (gimp-selection-none img)
    (gimp-by-color-select p-layer '(128 128 128) 25 REPLACE TRUE TRUE 3 FALSE)
    (gimp-hue-saturation drawable 0 hue2 sat2 0)
    (gimp-selection-none img)
    (gimp-image-remove-layer img p-layer)

;;wiF̌
    (gimp-palette-set-foreground bg-color)
    (gimp-image-add-layer img bg-layer 1)
    (gimp-drawable-fill bg-layer FG-IMAGE-FILL)

;;bumpmap
    (if (< 0 blur)
    (begin
	(gimp-image-add-layer img bp-layer 0)
	(gimp-layer-add-alpha bp-layer)
	(gimp-selection-layer-alpha bp-layer)
	(gimp-selection-shrink img 1)
	(gimp-palette-set-foreground '(255 255 255))
	(gimp-edit-fill bp-layer FG-IMAGE-FILL)
	(gimp-selection-invert img)
	(gimp-layer-set-preserve-trans bp-layer FALSE)
	(gimp-palette-set-foreground '(0 0 0))
	(gimp-edit-fill bp-layer FG-IMAGE-FILL)
	(gimp-selection-none img)
	(plug-in-gauss-iir2 1 img bp-layer blur blur)
	(plug-in-bump-map 1 img drawable bp-layer 135 45 (+ 3 (/ blur 2)) -1 -1 0 0 TRUE FALSE LINEAR)
	(gimp-image-remove-layer img bp-layer)
    ))

;    (if (= ft TRUE)
;    (gimp-image-merge-visible-layers img 0)                 ;摜̓
;    )

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-active old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-undo-push-group-end img)
    (gimp-displays-flush)
))



;摜H{
(define (script-fu-22mhmarbleimgh img drawable msize turb hue1 hue2 sat1 sat2 blur bg-color)
  (let* (
	(img2 (car (gimp-channel-ops-duplicate img)))
	(drawable2 (car (gimp-image-get-active-layer img2)))
	)
	(script-fu-22mhmarbleimg img2 drawable2 msize turb hue1 hue2 sat1 sat2 blur bg-color)
	(gimp-display-new img2)
  )
)

(script-fu-register "script-fu-22mhmarbleimgh"
		    "<Image>/Script-Fu/MH/marble"
		    "22mhmarble"
		    "Kiki"
		    "Kiki"
		    "2005/11"
		    "RGB*"
		    SF-IMAGE		"Image"			0
		    SF-DRAWABLE		"Drawable"		0
		    SF-ADJUSTMENT	"Marble Size"		'(8 0.1 16 1 2 1 0)
                    SF-TOGGLE		"Turbulent"		FALSE
		    SF-ADJUSTMENT	"Hue1"			'(50 1 180 1 2 0 0)
		    SF-ADJUSTMENT	"Hue2"			'(-50 -180 -1 1 2 0 0)
		    SF-ADJUSTMENT	"Saturation1"		'(0 0 100 1 2 0 0)
		    SF-ADJUSTMENT	"Saturation2"		'(0 -100 0 1 2 0 0)
		    SF-ADJUSTMENT	"bump size"		'(5 0 50 1 2 0 0)
		    SF-COLOR		"Background Color"	'(255 255 222)
)
