;;mhpaint
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhpaint text size font mode psize bg-mode bg-color bg-grad bg-pat s-color sblur soff)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 12) 4) TRUE size PIXELS font)))
;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))
;;wi
	 (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 NORMAL)))
	 (paint-layer (car (gimp-layer-new img width height RGB-IMAGE "paint" 100 NORMAL)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))
)
(gimp-image-undo-disable img)
;;TCY
    (gimp-image-resize img width height 0 0)

    (script-fu-mhpaintimg img text-layer mode psize bg-mode bg-color bg-grad bg-pat s-color sblur soff)

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-active old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mhpaint"
			"<Image>/File/Create/Logos/Paint..."
			"mhpaint"
			"Kiki"
			"Kiki"
			"2013/10"
			""
			SF-STRING	"Text String"	"Paint"
			SF-ADJUSTMENT	"Font Size (pixels)"	'(150 2 1000 1 10 0 1)
			SF-FONT		"Font"		"Cooper Black"
			SF-OPTION	"mode"		'(_"0(colorful)" _"1(red)" _"2(yellow)" 
						_"3(green)" _"4(watercolor)" _"5(blue)" _"6(magenta)")
			SF-ADJUSTMENT	"Paint size"	'(10 5 30 1 2 0 0)
			SF-OPTION	"bg mode"          '(_"color" _"gradient" _"pattern")
			SF-COLOR	"Background Color"	'(255 232 252)
			SF-GRADIENT "Background Gradient"     "Yellow Orange"
			SF-PATTERN  "Background Pattern"      "Wood"
			SF-COLOR	"Shadow Color"	'(87 32 45)
			SF-ADJUSTMENT	"shadow blur"	'(3 0 100 1 2 0 1)
			SF-ADJUSTMENT	"shadow offset"	'(2 0 100 1 2 0 1)
)

(define (script-fu-mhpaintimg img drawable mode psize bg-mode bg-color bg-grad bg-pat s-color sblur soff)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))

;;wi
	 (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 NORMAL)))
	 (paint-layer (car (gimp-layer-new img width height RGB-IMAGE "paint" 100 NORMAL)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))

	 (shou)
)
    (gimp-image-undo-group-start img)

    (gimp-selection-layer-alpha drawable)
    (gimp-selection-sharpen img)
    (gimp-image-add-layer img paint-layer 1)
    (gimp-selection-none img)
    (gimp-edit-clear paint-layer)
    (cond ((= mode 0)
	(gimp-palette-set-foreground '(190 190 190))
        (if (< psize 7) (gimp-palette-set-foreground '(190 185 190)))
    )
	((= mode 1)
	(gimp-palette-set-foreground '(255 190 190))
        (if (< psize 9) (gimp-palette-set-foreground '(225 145 145)))
        (if (> psize 16) (gimp-palette-set-foreground '(190 175 175)))
    )
	((= mode 2)
	(gimp-palette-set-foreground '(240 240 170))
        (if (< psize 7) (gimp-palette-set-foreground '(255 250 110)))
        (if (> psize 16) (gimp-palette-set-foreground '(190 190 130)))
    )
	((= mode 3)
	(gimp-palette-set-foreground '(160 190 160))
        (if (> psize 15) (gimp-palette-set-foreground '(160 170 160)))
    )
	((= mode 4)
	(gimp-palette-set-foreground '(170 255 255))
        (if (< psize 7) (gimp-palette-set-foreground '(170 245 255)))
        (if (> psize 16) (gimp-palette-set-foreground '(180 215 215)))
    )
	((= mode 5)
	(gimp-palette-set-foreground '(210 210 255))
        (if (> psize 16) (gimp-palette-set-foreground '(210 210 235)))
    )
	((= mode 6)
	(gimp-palette-set-foreground '(200 150 200))
        (if (> psize 16) (gimp-palette-set-foreground '(180 150 180)))
    ))

    (gimp-drawable-fill paint-layer FG-IMAGE-FILL)
    (gimp-selection-layer-alpha drawable)
    (gimp-selection-grow img 3)
    (plug-in-noisify 1 img paint-layer TRUE 1.0 1.0 1.0 1.0)
    (plug-in-noisify 1 img paint-layer TRUE 1.0 1.0 1.0 1.0)
    (gimp-selection-none img)
    (plug-in-pixelize 1 img paint-layer psize)
    (gimp-hue-saturation paint-layer 0 0 0 100)
    (gimp-hue-saturation paint-layer 0 0 0 100)
    (gimp-hue-saturation paint-layer 0 0 0 100)
    (if (> psize 10)
    (begin
    (plug-in-despeckle 1 img paint-layer psize 0 -1 200)
;    (gimp-hue-saturation paint-layer 0 0 0 (* psize 3.3))
    )
    (plug-in-despeckle 1 img paint-layer 10 0 -1 255)
    )
    (gimp-hue-saturation paint-layer 0 0 0 100)
    (gimp-hue-saturation paint-layer 0 0 -35 70)
    (gimp-selection-layer-alpha drawable)
    (gimp-layer-add-alpha paint-layer)
    (gimp-selection-invert img)
    (gimp-edit-clear paint-layer)
    (gimp-selection-none img)

    (gimp-image-add-layer img bg-layer 2)

;;TCY
    (gimp-image-resize img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (/ sblur 1.9) (/ sblur 1.9))
    (gimp-layer-resize drawable (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (/ sblur 1.9) (/ sblur 1.9))
    (gimp-layer-resize paint-layer (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (/ sblur 1.9) (/ sblur 1.9))
    (gimp-layer-resize bg-layer (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (/ sblur 1.9) (/ sblur 1.9))

    (gimp-layer-set-preserve-trans drawable TRUE)
    (gimp-palette-set-foreground s-color)
    (gimp-edit-fill drawable FG-IMAGE-FILL)
    (gimp-layer-set-preserve-trans drawable FALSE)
    (gimp-image-raise-layer img paint-layer)
    (if (>= sblur 1) (plug-in-gauss-iir2 1 img drawable sblur sblur))
    (gimp-layer-translate drawable soff soff)
    (gimp-layer-set-opacity drawable 75)

;;wiF̌
    (gimp-palette-set-foreground bg-color)
    (gimp-drawable-fill bg-layer FG-IMAGE-FILL)
    (cond((= bg-mode 1)
       (gimp-gradients-set-active bg-grad)
       (gimp-blend bg-layer CUSTOM NORMAL LINEAR 100 20 REPEAT-NONE FALSE 0 0 0 0 0 0 width height))
    ((= bg-mode 2)
       (gimp-selection-all img)
       (gimp-patterns-set-pattern bg-pat)
       (gimp-bucket-fill bg-layer PATTERN-BUCKET-FILL NORMAL 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))

    (set! width (car (gimp-drawable-width bg-layer)))		;add
    (set! height (car (gimp-drawable-height bg-layer)))		;add
    (if (>= soff sblur ) (set! shou sblur)			;add
	(set! shou soff)					;add
    )								;add
    (gimp-image-resize img (- width (/ shou 2))  (- height (/ shou 2)) (- 0 (/ shou 2)) (- 0 (/ shou 2)))	;add
    (gimp-layer-resize bg-layer (- width (/ shou 2))  (- height (/ shou 2)) (- 0 (/ shou 2)) (- 0 (/ shou 2)))	;add

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-active old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-group-end img)
    (gimp-displays-flush)

))

(script-fu-register "script-fu-mhpaintimg"
			"<Image>/Script-Fu/MH/paint"
			"mhpaintimg"
			"Kiki"
			"Kiki"
			"2013/10"
			"RGBA"
			SF-IMAGE        "Image"		0
			SF-DRAWABLE     "Drawable"	0
			SF-OPTION	"mode"		'(_"0(colorful)" _"1(red)" _"2(yellow)" 
						_"3(green)" _"4(watercolor)" _"5(blue)" _"6(magenta)")
			SF-ADJUSTMENT    "Paint size"	'(10 5 30 1 2 0 0)
			SF-OPTION	"bg mode"          '(_"color" _"gradient" _"pattern")
			SF-COLOR    "Background Color"	'(255 232 252)
			SF-GRADIENT "Background Gradient"     "Yellow Orange"
			SF-PATTERN  "Background Pattern"      "Wood"
			SF-COLOR    "Shadow Color"	'(87 32 45)
			SF-ADJUSTMENT  "shadow blur"	'(3 0 100 1 2 0 1)
			SF-ADJUSTMENT  "shadow offset"	'(2 0 100 1 2 0 1)
)
