;;mhshcolor
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhshcolor text size font md text-color text-gradient gmode pat blur)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 10) 4) TRUE size PIXELS font)))
;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))
)
(gimp-image-undo-disable img)
;;TCY
    (gimp-image-resize img width height 0 0)

(script-fu-mhshcolorimg img text-layer md text-color text-gradient gmode pat blur)

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mhshcolor"
		    "<Image>/File/Create/Logos/Sh Color..."
		    "mhshcolor"
		    "Kiki"
		    "Kiki"
		    "2012/1"
		    ""
		    SF-STRING     "Text String"      "Sh Color"
		    SF-ADJUSTMENT "Font Size (pixels)" '(100 2 1000 1 10 0 1)
		    SF-FONT       "Font"             "degaussed pipeline"
                    SF-OPTION     "mode"             '(_"color" _"grad" _"pattern")
		    SF-COLOR      "Text Color"       '(241 162 162)
                    SF-GRADIENT   "Gradient"         "Full saturation spectrum CCW"
                    SF-OPTION     "Grad-mode"        '(_"0(GRADIENT-LINEAR)" _"1" _"2" _"3" _"4" _"5" _"6" _"7" _"8" _"9" _"10")
                    SF-PATTERN    "Pattern"          "Burlap"
		    SF-ADJUSTMENT "blur"             '(5 1 100 1 2 0 0))

(define (script-fu-mhshcolorimg img drawable md text-color text-gradient gmode pat blur)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
;;wi
	 (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 NORMAL-MODE)))

;;ǉC[
	 (gray (car (gimp-layer-new img width height RGB-IMAGE "gray" 100 MULTIPLY-MODE)))
	 (color (car (gimp-layer-new img width height RGB-IMAGE "color" 100 SCREEN-MODE)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))

;;2.4ǉ
	 (ue)
	 (k1)
	 (l1)
	 (k2)
)
    (gimp-image-undo-group-start img)
;;TCY
    (gimp-image-resize img width height 0 0)

    (set! ue (car (gimp-layer-copy drawable 1)))

;;œhԂ
    (gimp-palette-set-foreground '(0 0 0))
    (gimp-layer-set-preserve-trans drawable TRUE)
    (gimp-edit-fill drawable FOREGROUND-FILL)

    (gimp-palette-set-foreground '(255 255 255))
    (gimp-image-add-layer img bg-layer 1)
    (gimp-drawable-fill bg-layer FOREGROUND-FILL)

    (set! k1 (car (gimp-image-merge-down img drawable 0)))

    (set! l1 (car (gimp-layer-copy k1 1)))
    (gimp-image-add-layer img l1 0)
    (plug-in-gauss-iir2 1 img l1 blur blur)
    (gimp-layer-translate l1 (/ blur 2) (/ blur 2))
    (gimp-invert l1)

    (gimp-image-add-layer img gray 1)
    (gimp-palette-set-foreground '(128 128 128))
    (gimp-drawable-fill gray FOREGROUND-FILL)

    (gimp-image-add-layer img color 0)
    (gimp-palette-set-foreground text-color)
    (gimp-drawable-fill color FOREGROUND-FILL)
    (cond((= md 1)
      (gimp-gradients-set-gradient text-gradient)
      (gimp-edit-blend color CUSTOM-MODE NORMAL-MODE gmode 100 20 REPEAT-NONE FALSE FALSE 0 0 FALSE 0 0 width height))
    ((= md 2)
       (gimp-selection-all img)
       (gimp-patterns-set-pattern pat)
       (gimp-edit-bucket-fill color PATTERN-BUCKET-FILL NORMAL-MODE 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))

    (set! k2 (car (gimp-image-merge-down img color 0)))
    (gimp-layer-set-mode k2 SCREEN-MODE)

    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-group-end img)
    (gimp-displays-flush)
))

(script-fu-register "script-fu-mhshcolorimg"
		    "<Image>/Script-Fu/MH/shcolorimg"
		    "mhshcolorimg"
		    "Kiki"
		    "Kiki"
		    "2012/1"
		    "RGBA"
		    SF-IMAGE      "Image"    0
		    SF-DRAWABLE   "Drawable" 0
                    SF-OPTION     "mode"             '(_"color" _"grad" _"pattern")
		    SF-COLOR      "Text Color"       '(241 162 162)
                    SF-GRADIENT   "Gradient"         "Full saturation spectrum CCW"
                    SF-OPTION     "Grad-mode"        '(_"0(GRADIENT-LINEAR)" _"1" _"2" _"3" _"4" _"5" _"6" _"7" _"8" _"9" _"10")
                    SF-PATTERN    "Pattern"          "Burlap"
		    SF-ADJUSTMENT "blur"             '(5 1 100 1 2 0 0))
