; Space Text rel 0.01
; Created by Graechan
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
(define (script-fu-space-text
                                      text
									  letter-spacing
									  line-spacing
                                      font-in 
                                      font-size
									  bkg
									  bkg-bodies
									  conserve
                                      
									  )
  (let* (
         (image (car (gimp-image-new 256 256 RGB)))         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width 0)
         (height 0)
         (bkg-layer 0)
		 (text-selection 0)
		 (H1 4)
		 (H2 4)
		 (V1 4)
		 (V2 4)
		 (V3 4)
		 (V4 4)
		 (Object_Name "myPattern")
		 (inner-bevel 0)
		 ;(bevel-selection 0)
		 (inner-shadow 0)
		 (flare-layer 0)
		 (cnt bkg-bodies)
		 (star-type 0)
		 (gflare-name 0)
		 
		 
         
         )
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))

;;;;Add the text layer for a temporary larger Image size
    (set! text-layer (car (gimp-text-fontname image -1 0 0 text (round (/ 350 4)) TRUE 350 PIXELS font)))
;;;;adjust text on line
	(gimp-text-layer-set-justification text-layer 2)
	(gimp-text-layer-set-letter-spacing text-layer letter-spacing)
	(gimp-text-layer-set-line-spacing text-layer line-spacing)
	
    (set! width (car (gimp-drawable-width text-layer)))
    (set! height (car (gimp-drawable-height text-layer)))    
    (gimp-image-remove-layer image size-layer)
    (gimp-image-resize-to-layers image)
	
;;;;set the text clolor    
    (gimp-context-set-foreground "Black")
	(gimp-selection-layer-alpha text-layer)
	(set! text-selection (car (gimp-selection-save image))) ;(gimp-selection-load text-selection)
	(gimp-edit-fill text-layer FOREGROUND-FILL)

	(gimp-selection-load text-selection)

    
	(the-Motif_Geometrique_1_3D_samj H1 H2 V1 V2 V3 V4 "Black" "Lightgray" "Gray" TRUE Object_Name)	
	(gimp-context-set-pattern (strcat Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) ) ) )
	(gimp-edit-fill text-layer PATTERN-FILL)
	(the-inner-shadow image text-layer "Black" 30 20 0 20 75 0)
	(set! inner-shadow (car (gimp-image-get-active-layer image)))
	(the-beveller image text-layer 18 0 0 10 0 0 135 30 3 3 0 FALSE)
	(set! inner-bevel (car (gimp-image-get-active-layer image)))
	(gimp-curves-spline inner-bevel 0 10 #(0 0 65 255 126 0 188 255 255 0))
	(gimp-image-set-active-layer image text-layer)
	(if (= bkg FALSE) (script-fu-drop-shadow image text-layer 8 8 15 '(0 0 0) 80 FALSE))

;;;;Scale Image to it's original size;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (gimp-image-scale-full image final-width final-height 2)
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))
    
;;;;create the background layer    
	(if (= bkg TRUE) (begin
	(set! flare-layer (car (gimp-layer-new image width height RGBA-IMAGE "Space Bodies" 100 NORMAL-MODE)))
    (gimp-image-add-layer image flare-layer (+ (car (gimp-image-get-layer-position image text-layer)) 1)) ;under
	(gimp-context-set-foreground '(0 0 10))
	(gimp-drawable-fill flare-layer FOREGROUND-FILL)
	
	(while (> cnt 0)
	(set! star-type (random 7))
    (set! gflare-name
			(cond 
				(( equal? star-type 0 ) "Bright_Star" )
				(( equal? star-type 1 ) "Classic" )
				(( equal? star-type 2 ) "Default" )
				(( equal? star-type 3 ) "Distant_Sun" )
				(( equal? star-type 4 ) "Gflare_101" )
				(( equal? star-type 5 ) "Gflare_102" )
				(( equal? star-type 6 ) "Hidden_Planet" )
				(( equal? star-type 7 ) "Distant_Sun" )))
	(plug-in-gflare 1 image flare-layer gflare-name (random width) (random height) (+ (random 30) 20) 0 0 60 1 FALSE 3 0.20)
	(set! cnt (- cnt 1)))
	)
	)
	
;;;;finish the script	
	(if (= conserve FALSE) (begin
	(set! text-layer (car (gimp-image-merge-visible-layers image 0)))
    (gimp-image-remove-channel image text-selection)))	
    (gimp-drawable-set-name text-layer text)
	(gimp-context-pop)

    (gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-space-text"
  "Space Text..."
  "Create an image with a text layer over a background layer"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "June 2011"
  ""
  SF-TEXT       "Text"    "Space Text"
  SF-ADJUSTMENT "Letter Spacing" '(0 -100 100 1 5 0 0)
  SF-ADJUSTMENT "Line Spacing" '(0 -100 100 1 5 0 0)
  SF-FONT       "Font"               "Orbit Racer"
  SF-ADJUSTMENT "Font size (pixels)" '(250 6 500 1 1 0 1)
  SF-TOGGLE     "Apply Space Bkg"   TRUE
  SF-ADJUSTMENT "Space Bodies" '(40 1 100 1 10 0 0)
  SF-TOGGLE     "Keep the Layers"   FALSE
  )
(script-fu-menu-register "script-fu-space-text" "<Image>/File/Create/Logos")
  
(define	
	(
		the-Motif_Geometrique_1_3D_samj
		H1
		H2
		V1
		V2
		V3
		V4
		Color_1
		Color_2
		Color_3
		Save_Pattern
		Object_Name


		
	)
	(let* 
		(

			(message (car (gimp-message-get-handler)))
			(old_context_transform_direction (car (gimp-context-get-transform-direction)))
			(old_context_interpolation (car (gimp-context-get-interpolation)))
			(old_context_recursion (car (gimp-context-get-transform-recursion)))
			(old_context_transform_resize (car (gimp-context-get-transform-resize)))
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))

			(old_context-antialias (car (gimp-context-get-antialias)))
			(old_context-feather (car (gimp-context-get-feather)))
			(old_context-feather-radiusx (car (gimp-context-get-feather-radius)))
			(old_context-feather-radiusy (cadr (gimp-context-get-feather-radius)))
			(old_context-sample-merged (car (gimp-context-get-sample-merged)))
			(old_ontext-sample-criterion (car (gimp-context-get-sample-criterion)))
			(old_context-sample-threshold (car (gimp-context-get-sample-threshold)))
			(old_context-sample-transparent (car (gimp-context-get-sample-transparent)))

			(old-brush-size (car (gimp-context-get-brush-size)))
			(old-brush-aspect-ratio (car (gimp-context-get-brush-aspect-ratio)))
			(old-brush-angle (car (gimp-context-get-brush-angle)))
			(old-brush-name (car (gimp-context-get-brush)))

			; crer une image pour le motif
			(image (car (gimp-image-new (+ H1 H2) (+ V1 V2 V3 V4) 0)))

			; crer le calque calque_motif
			(calque_motif (car (gimp-layer-new image (+ H1 H2) (+ V1 V2 V3 V4) 1 "calque_motif" 100 0)))

			; array
			(*points*)

			(path)




		)

		(gimp-undo-push-group-start image)

		(gimp-image-insert-layer image calque_motif -1 0)

		(gimp-layer-add-alpha calque_motif)







;******************************************************************************************************
; 
;******************************************************************************************************


	; triangle haut gauche
		
		(set! *points* (cons-array 6 'double))

		; dterminer les coordonnes des 3 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 0 )					; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 0 )					; y1
		(vector-set! *points* 4 0 )					; x2
		(vector-set! *points* 5 V1 )				; y2


		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			6						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)







	; losange haut gauche

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 V1 )				; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 0 )					; y1
		(vector-set! *points* 4 H1 )				; x2
		(vector-set! *points* 5 V1 )				; y2
		(vector-set! *points* 6 0  )				; x3
		(vector-set! *points* 7 (+ V1 V2) )			; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_1)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)


	; losange milieu

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 (+ V1 V2) )			; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 V1 )				; y1
		(vector-set! *points* 4 (+ H1 H2) )			; x2
		(vector-set! *points* 5 (+ V1 V2) )			; y2
		(vector-set! *points* 6 H1  )				; x3
		(vector-set! *points* 7 (+ V1 V2 V3) )		; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)


	; losange bas gauche

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 (+ V1 V2) )			; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 (+ V1 V2 V3) )		; y1
		(vector-set! *points* 4 H1 )				; x2
		(vector-set! *points* 5 (+ V1 V2 V3 V4) )	; y2
		(vector-set! *points* 6 0 )					; x3
		(vector-set! *points* 7 (+ V1 V2 V3) )		; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_2)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)


	; triangle bas gauche
		
		(set! *points* (cons-array 6 'double))

		; dterminer les coordonnes des 3 points
		(vector-set! *points* 0 0 )					; x0
		(vector-set! *points* 1 (+ V1 V2 V3) )		; y0
		(vector-set! *points* 2 H1 )				; x1
		(vector-set! *points* 3 (+ V1 V2 V3 V4) )	; y1
		(vector-set! *points* 4 0 )					; x2
		(vector-set! *points* 5 (+ V1 V2 V3 V4) )	; y2


		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			6						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)




	; triangle haut droite
		
		(set! *points* (cons-array 6 'double))

		; dterminer les coordonnes des 3 points
		(vector-set! *points* 0 H1 )				; x0
		(vector-set! *points* 1 0 )					; y0
		(vector-set! *points* 2 (+ H1 H2) )			; x1
		(vector-set! *points* 3 0 )					; y1
		(vector-set! *points* 4 (+ H1 H2) )			; x2
		(vector-set! *points* 5 V1 )				; y2


		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			6						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)




	; losange haut droite

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 H1 )			; x0
		(vector-set! *points* 1 0 )				; y0
		(vector-set! *points* 2 (+ H1 H2) )		; x1
		(vector-set! *points* 3 V1 )			; y1
		(vector-set! *points* 4 (+ H1 H2) )		; x2
		(vector-set! *points* 5 (+ V1 V2) )		; y2
		(vector-set! *points* 6 H1  )			; x3
		(vector-set! *points* 7 V1 )			; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_2)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)


	; losange bas droite

		(set! *points* (cons-array 8 'double))

		; dterminer les coordonnes des 4 points
		(vector-set! *points* 0 (+ H1 H2) )			; x0
		(vector-set! *points* 1 (+ V1 V2) )			; y0
		(vector-set! *points* 2 (+ H1 H2) )			; x1
		(vector-set! *points* 3 (+ V1 V2 V3) )		; y1
		(vector-set! *points* 4 H1 )				; x2
		(vector-set! *points* 5 (+ V1 V2 V3 V4) )	; y2
		(vector-set! *points* 6 H1  )				; x3
		(vector-set! *points* 7 (+ V1 V2 V3) )		; y3

		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			8						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_1)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)




	; triangle bas droite
		
		(set! *points* (cons-array 6 'double))

		; dterminer les coordonnes des 3 points
		(vector-set! *points* 0 (+ H1 H2) )			; x0
		(vector-set! *points* 1 (+ V1 V2 V3) )		; y0
		(vector-set! *points* 2 (+ H1 H2) )			; x1
		(vector-set! *points* 3 (+ V1 V2 V3 V4) )	; y1
		(vector-set! *points* 4 H1 )				; x2
		(vector-set! *points* 5 (+ V1 V2 V3 V4) )	; y2


		(gimp-image-select-polygon 
			image					; image 
			2						; operation 
			6						; num-segs 
			*points*				; segs
		)

		(gimp-context-set-foreground Color_3)

		(gimp-edit-bucket-fill calque_motif 0 0 100 0 FALSE 0 0)

		(gimp-selection-none image)



		(if (= Save_Pattern 1)
			(begin
				; dterminer le chemin complet du motif  sauvegarder
				(set! path (string-append gimp-directory "/patterns/" (strcat Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) )   ".pat") ) )

				; sauvegarder le motif sous :  "Object_Name"_"Selection_Size".pat
				(file-pat-save 1 image (car (gimp-image-get-active-layer image)) path path (strcat Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) ) ) )

				; mettre  jour les motifs dans Gimp
				(gimp-patterns-refresh)

				; choisir le motif comme motif actif
				(gimp-context-set-pattern (strcat Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) ) ) )

				(gimp-image-delete image)

				;(gimp-message (string-append "Pattern Path :\n" path "\nPattern Name:\n" Object_Name "_" (number->string (+ H1 H2) ) "_" (number->string (+ V1 V2 V3 V4) ) ) )
			)
			;else
			(begin

				(gimp-item-set-visible calque_motif TRUE)

				; afficher l'image
				(gimp-display-new image)

				(gimp-undo-push-group-end image)
				(gimp-displays-flush)

			)
		)









;******************************************************************************************************
; 
;******************************************************************************************************







;******************************************************************************************************

		;; rtablir le mode message
		(gimp-message-set-handler message)

		(gimp-context-set-transform-direction old_context_transform_direction )
		(gimp-context-set-interpolation old_context_interpolation)
		(gimp-context-set-transform-recursion old_context_recursion)
		(gimp-context-set-transform-resize old_context_transform_resize)
		(gimp-context-set-background old-bg)
		(gimp-context-set-foreground old-fg)


		(gimp-context-set-antialias old_context-antialias)
		(gimp-context-set-feather old_context-feather)
		(gimp-context-set-feather-radius old_context-feather-radiusx old_context-feather-radiusy)
		(gimp-context-set-sample-merged old_context-sample-merged)
		(gimp-context-set-sample-criterion old_ontext-sample-criterion)
		(gimp-context-set-sample-threshold old_context-sample-threshold)
		(gimp-context-set-sample-transparent old_context-sample-transparent)

		(gimp-context-set-brush-default-size)
		(gimp-context-set-brush-size old-brush-size)
		(gimp-context-set-brush-aspect-ratio old-brush-aspect-ratio)
		(gimp-context-set-brush-angle old-brush-angle)		
		(gimp-context-set-brush old-brush-name)






	)
)

(define (the-inner-shadow
            image ;
            layer ;
            color ;
            angle ;
            offset-radius ;
            radius ;
            blur-radius ;
            opacity ;
            layer-mode ;
        )

    (let* (
                        
        )
		(gimp-context-push)
        (gimp-image-undo-group-start image)
        (common1 image layer color angle offset-radius radius blur-radius
        opacity layer-mode "Inner Shadow" 1)
		(gimp-selection-none image)
        (gimp-image-undo-group-end image)
        (gimp-displays-flush)
		(gimp-context-pop)
    )
)

(define (common1
            image ;
            layer ;
            color ;
            angle ;
            offset-radius ;
            effect-radius ;
            blur-radius ;
            opacity ;
            layer-mode ;
            layer-name ;
            color-side ; (Outer(0) Inner(1) Inner-Inverse(2))			
         )

    (let* (
        (width (car (gimp-drawable-width layer)))
        (height (car (gimp-drawable-height layer)))
        (radians (/ (* 2 *pi* angle) 360))
        (x-offset (* offset-radius (sin radians)))
        (y-offset (* offset-radius (cos radians)))
        (target-layer (car (gimp-layer-copy layer TRUE)))
        (effect-layer (car (gimp-layer-new image width height RGBA-IMAGE layer-name opacity layer-mode)))
        (effect-mask (car (gimp-layer-create-mask effect-layer WHITE-MASK)))
        (effect-mask2 0)
		(alpha (car (gimp-drawable-has-alpha layer)))
		(sel (car (gimp-selection-is-empty image)))
		(selection 0)
      )
        (if (= alpha FALSE) (gimp-layer-add-alpha layer))
		(if (= sel TRUE) (gimp-selection-layer-alpha layer))
		(set! selection (car (gimp-selection-save image)))
		(gimp-selection-none image)
        ;;
        (gimp-image-add-layer image effect-layer -1)

        (gimp-layer-add-mask effect-layer effect-mask)
        (if (= color-side 0)
        (gimp-invert effect-mask))
        (if (< 0 (car (gimp-layer-get-mask target-layer)))
        ;replaced 2005-11-13
       ; (gimp-image-remove-layer-mask image target-layer APPLY))
        (gimp-layer-remove-mask target-layer APPLY))

        ;;
        (gimp-context-set-background color)
        (gimp-drawable-fill effect-layer BACKGROUND-FILL)
        (gimp-selection-load selection)
        (if (= color-side 0)
            (gimp-selection-grow image effect-radius)
            (begin
                (gimp-selection-invert image)
                (gimp-selection-grow image effect-radius)
                (gimp-selection-invert image) ))
        (if (= color-side 0)
            (gimp-context-set-background '(255 255 255))
            (gimp-context-set-background '(0 0 0)))
            (gimp-edit-fill effect-mask BACKGROUND-FILL)
            (gimp-selection-none image)
            ;;
            (gimp-context-set-background '(0 0 0))
        (if (< 0 offset-radius)
            (gimp-drawable-offset effect-mask FALSE OFFSET-BACKGROUND x-offset y-offset))
        (if (< 0 blur-radius)
            (plug-in-gauss-iir2 1 image effect-mask blur-radius blur-radius))
        (if (= color-side 2)
            (gimp-invert effect-mask))

        (gimp-layer-remove-mask effect-layer APPLY)
        (set! effect-mask2 (car (gimp-layer-create-mask effect-layer BLACK-MASK)))

        (gimp-layer-add-mask effect-layer effect-mask2)
        (if (= color-side 0)
            (gimp-invert effect-mask2))
        (gimp-selection-load selection)
        (if (= color-side 0)
            (gimp-context-set-background '(0 0 0))
            (gimp-context-set-background '(255 255 255)))
        (gimp-edit-fill effect-mask2 BACKGROUND-FILL)
        (gimp-selection-none image)

        ;;
        (if (= color-side 0)
            (gimp-image-lower-layer image effect-layer))
		(gimp-selection-load selection)
		(gimp-image-remove-channel image selection)	
;        (gimp-image-set-active-layer image layer)		
        (list effect-layer)
		
    )
)

(define (the-beveller image layer
                               layer-mode
							   bev-type
							   bev-dir
							   bev-width
							   shape
							   prenoise
							   light-angle
							   light-elevation
							   depth
							   postblur
							   gloss
							   keep-selection-in
							   )
							  

 (let* (
            (width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
			(alpha (car (gimp-drawable-has-alpha layer)))
			(layer-name (car (gimp-drawable-get-name layer)))
			(image-channel 0)
			(bevel-layer 0)
			(name 0)
			(*newpoint* (cons-array 6 'double))
		    (*newpointx1* (cons-array 16 'double))
			(y1 0)
			(y2 0)
			(y3 0)
			(y4 0)
			(y5 0)
			(y6 0)
			(keep-selection keep-selection-in)
			(selection-bounds 0)
			(bounds-x1 0)
			(bounds-y1 0)
			(bounds-x2 0)
			(bounds-y2 0)
						
        )
	
	
	(gimp-context-push)
    (gimp-image-undo-group-start image)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))

	(if (= alpha FALSE) (gimp-layer-add-alpha layer))
	
;;;;check that a selection was made if not make one	
;	(if (= (car (gimp-selection-is-empty image)) TRUE) (set! keep-selection FALSE))
	(if (= (car (gimp-selection-is-empty image)) TRUE) (gimp-selection-layer-alpha layer))

;;;;find the selection co-ordinates	
	(set! selection-bounds (cdr (gimp-selection-bounds image)))
	(set! bounds-x1 (car selection-bounds));x coordinate of upper left corner of selection bounds
    (set! bounds-y1 (cadr selection-bounds));y coordinate of upper left corner of selection bounds
    (set! bounds-x2 (caddr selection-bounds));x coordinate of lower right corner of selection bounds
    (set! bounds-y2 (cadddr selection-bounds));y coordinate of lower right corner of selection bounds	
;;;;This means the width of the selection can be calculated as (x2 - x1), its height as (y2 - y1).
;	(if (and (= bev-type 1) (or (= (- bounds-x2 bounds-x1) width) (= (- bounds-y2 bounds-y1) height))) (gimp-image-resize image (+ width (* bev-width 2)) (+ height (* bev-width 2)) bev-width bev-width))
;	(set! width (car (gimp-image-width image)))
;	(set! height (car (gimp-image-height image)))
;	(gimp-layer-resize-to-image-size layer)
;;;;save the selection    
	(gimp-selection-save image)
	(set! image-channel (car (gimp-image-get-active-drawable image)))	
	(gimp-channel-set-opacity image-channel 100)	
	(gimp-drawable-set-name image-channel "image-channel")
	(gimp-image-set-active-layer image layer)
	
;;;;Add new layer with Bevel
    (if (= bev-type 0) (set! name "Inner bevel"))
    (if (= bev-type 1) (set! name "Outer bevel"))
    (gimp-selection-load image-channel)
    (gimp-image-set-active-layer image layer)    
    (set! bevel-layer (car (gimp-layer-new image width height RGBA-IMAGE name 100 layer-mode)))
    (gimp-image-add-layer image bevel-layer -1)
    (gimp-image-set-active-layer image bevel-layer)    
    (gimp-context-set-foreground '(0 0 0))
    (gimp-context-set-background '(255 255 255))
	(gimp-drawable-fill bevel-layer FOREGROUND-FILL)    
    (gimp-selection-grow image 3)
    (gimp-selection-feather image bev-width)
    (if (= bev-type 0) (gimp-selection-shrink image (/ bev-width 2)))
	(if (= bev-type 1) (gimp-selection-grow image (+ (/ bev-width 2) 1)))
    (gimp-edit-fill bevel-layer BACKGROUND-FILL)
;;;;apply shape curve
    (if (or (< shape 0) (> shape 0))
	(begin
					(aset *newpoint* 0 0)    ; set the arrays
					(aset *newpoint* 1 0)
					(aset *newpoint* 2 (round (+ (/ shape 10) 127)))
	                (aset *newpoint* 3 (+ shape 127))
					(aset *newpoint* 4 255)
					(aset *newpoint* 5 255)
	(gimp-curves-spline bevel-layer 0 6 *newpoint*)
    )
    )	
	

    (gimp-selection-all image)
	
;;;;invert colours of whole layer if down                
    (if (= bev-dir 1) (gimp-invert bevel-layer))
;;;;add prenoise
    (if (> prenoise 0) (plug-in-hsv-noise 1 image bevel-layer 4 0 0 prenoise))
                        						
;;;;emboss the selection    
    (plug-in-emboss RUN-NONINTERACTIVE image bevel-layer light-angle light-elevation depth 1);Emboss

;;;;gloss the bevel-layer    
     (if (> gloss 0)
				(begin
                    (set! y1 (* 1.0 gloss))
					(set! y2 (* 3.0 gloss)) 
                    (set! y3 (* 9.6 gloss))
                    (set! y4 (* 3.2 gloss))
                    (set! y5 (* 4.0 gloss))
                    (set! y6 (* 0.4 gloss))
					
					(aset *newpointx1* 0 0)    ; set the arrays
					(aset *newpointx1* 1 0)
					(aset *newpointx1* 2 63)
	                (aset *newpointx1* 3 (+ 63 y1))
					(aset *newpointx1* 4 95)
					(aset *newpointx1* 5 (+ 95 y2))
					(aset *newpointx1* 6 127)
					(aset *newpointx1* 7 (- 127 y3))
					(aset *newpointx1* 8 156)
					(aset *newpointx1* 9 (+ 156 y4))
					(aset *newpointx1* 10 191)
					(aset *newpointx1* 11 (- 191 y5))
					(aset *newpointx1* 12 223)
					(aset *newpointx1* 13 (+ 223 y6))
					(aset *newpointx1* 14 255)
					(aset *newpointx1* 15 255)
					;(0,0, 63,(63 + y1), 95,(95 + y2), 127,(127 - y3), 156,(156 + y4), 191,(191 - y5), 223,(223 + y6), 255,255)
	 
	(gimp-curves-spline bevel-layer 0 16 *newpointx1*)
	 )
	 )
	(gimp-selection-load image-channel)
    (if (= bev-type 0) (begin
	(gimp-selection-shrink image (- bev-width (round (/ bev-width 3))))
    (gimp-edit-clear bevel-layer)))
  	(if (= bev-type 1) (begin
	(gimp-selection-grow image (+ bev-width 1))
	(gimp-selection-invert image)
	(gimp-edit-clear bevel-layer)))
;postblur                
	(if (> postblur 0) (plug-in-gauss-rle2 RUN-NONINTERACTIVE image bevel-layer postblur postblur))
	
	(gimp-layer-set-lock-alpha bevel-layer FALSE)
	
;reload selection
    (gimp-selection-load image-channel)
                
;clear excess
    (if (= bev-type 0) 
	(begin
	(gimp-selection-shrink image 1)
	(gimp-selection-invert image) 
	(gimp-edit-clear bevel-layer)
	(gimp-edit-clear layer)
	(gimp-selection-invert image)))

	(if (= bev-type 1) 
	(begin
	(gimp-selection-shrink image 1)
	(gimp-edit-clear bevel-layer)))
    
 
;;;;Clean up the layers
    (if (= keep-selection FALSE) (gimp-selection-none image))
	(gimp-image-remove-channel image image-channel)
	(if (= alpha FALSE) (gimp-layer-flatten layer))
	;(set! layer (car (gimp-image-merge-down image bevel-layer EXPAND-AS-NECESSARY)))
	(gimp-drawable-set-name layer layer-name)
	(gimp-image-set-active-layer image bevel-layer)

	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)
    
 )
)